## mingw-w64-liboqs-0.15.0-1.src.tar.zst

=== CMakeLists.txt ===
# SPDX-License-Identifier: MIT

cmake_minimum_required (VERSION 3.15)
# option() honors normal variables.
# see: https://cmake.org/cmake/help/git-stage/policy/CMP0077.html
if(POLICY CMP0077)
    cmake_policy(SET CMP0077 NEW)
endif()
# Honor symbol visibility properties for all target types.
# see: https://cmake.org/cmake/help/git-stage/policy/CMP0063.html
if(POLICY CMP0063)
    cmake_policy(SET CMP0063 NEW)
endif()
if(POLICY CMP0066)
    cmake_policy(SET CMP0066 NEW)
endif()
if(POLICY CMP0067)
    cmake_policy(SET CMP0067 NEW)
endif()

project(liboqs C ASM)

option(OQS_DIST_BUILD "Build distributable library with optimized code for several CPU microarchitectures. Enables run-time CPU feature detection." ON)
option(OQS_BUILD_ONLY_LIB "Build only liboqs and do not expose build targets for tests, documentation, and pretty-printing available." OFF)
set(OQS_MINIMAL_BUILD "" CACHE STRING "Only build specifically listed algorithms.")
option(OQS_LIBJADE_BUILD "Enable formally verified implementation of supported algorithms from libjade." OFF)
option(OQS_PERMIT_UNSUPPORTED_ARCHITECTURE "Permit compilation on an an unsupported architecture." OFF)
option(OQS_STRICT_WARNINGS "Enable all compiler warnings." OFF)
option(OQS_EMBEDDED_BUILD "Compile liboqs for an Embedded environment without a full standard library." OFF)
option(OQS_USE_CUPQC "Utilize cuPQC as the backend for supported PQC algorithms." OFF)
option(OQS_USE_ICICLE "Utilize ICICLE as the backend for supported PQC algorithms." OFF)

# Libfuzzer isn't supported on gcc
if('${CMAKE_C_COMPILER_ID}' STREQUAL 'Clang')
    option(OQS_BUILD_FUZZ_TESTS "Build fuzz test suite" OFF)
endif()


set(OQS_OPT_TARGET auto CACHE STRING "The target microarchitecture for optimization.")

set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(OQS_VERSION_MAJOR 0)
set(OQS_VERSION_MINOR 15)
set(OQS_VERSION_PATCH 0)
set(OQS_VERSION_PRE_RELEASE "")
set(OQS_VERSION_TEXT "${OQS_VERSION_MAJOR}.${OQS_VERSION_MINOR}.${OQS_VERSION_PATCH}${OQS_VERSION_PRE_RELEASE}")
set(OQS_COMPILE_BUILD_TARGET "${CMAKE_SYSTEM_PROCESSOR}-${CMAKE_HOST_SYSTEM}")
set(OQS_MINIMAL_GCC_VERSION "7.1.0")
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Determine the flags for fuzzing. Use OSS-Fuzz's configuration if available, otherwise fall back to defaults.
if(DEFINED ENV{LIB_FUZZING_ENGINE})
    set(FUZZING_ENGINE $ENV{LIB_FUZZING_ENGINE})
    set(FUZZING_COMPILE_FLAGS "")
    set(FUZZING_LINK_FLAGS "${FUZZING_ENGINE}")
else()
    set(FUZZING_COMPILE_FLAGS "-fsanitize=fuzzer,address")
    set(FUZZING_LINK_FLAGS "-fsanitize=fuzzer,address")
endif()

# heuristic check to see whether we're running on a RaspberryPi
if(EXISTS "/opt/vc/include/bcm_host.h")
	add_definitions( -DOQS_USE_RASPBERRY_PI )
endif()

if(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64|amd64|AMD64")
    set(ARCH "x86_64")
    set(ARCH_X86_64 ON)
    if(${OQS_DIST_BUILD})
        set(OQS_DIST_X86_64_BUILD ON)
    endif()
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "x86|i586|i686")
    set(ARCH "i586")
    set(ARCH_X86 ON)
    if(${OQS_DIST_BUILD})
        set(OQS_DIST_X86_BUILD ON)
    endif()
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "aarch64|arm64|arm64v8")
    set(ARCH "arm64v8")
    set(ARCH_ARM64v8 ON)
    if(${OQS_DIST_BUILD})
        set(OQS_DIST_ARM64_V8_BUILD ON)
    endif()
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "armel|armhf|armv7|arm32v7")
    set(ARCH "arm32v7")
    set(ARCH_ARM32v7 ON)
    if(${OQS_DIST_BUILD})
        set(OQS_DIST_ARM32_V7_BUILD ON)
    endif()
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "ppc64le|powerpc64le")
    set(ARCH "ppc64le")
    set(ARCH_PPC64LE ON)
    if(${OQS_DIST_BUILD})
        set(OQS_DIST_PPC64LE_BUILD ON)
    endif()
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "(ppc64|powerpc64)")
    message(WARNING "There is currently no CI for: " ${CMAKE_SYSTEM_PROCESSOR})
    set(ARCH "ppc64")
    set(ARCH_PPC64 ON)
    if(${OQS_DIST_BUILD})
        set(OQS_DIST_PPC64_BUILD ON)
    endif()
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "(ppc|powerpc)")
    message(WARNING "There is currently no CI for: " ${CMAKE_SYSTEM_PROCESSOR})
    # CMake uses uname to derive CMAKE_SYSTEM_PROCESSOR value, so on Darwin
    # the value is identical for ppc and ppc64. To have the right build arch
    # in 64-bit case, we use CMAKE_OSX_ARCHITECTURES.
    if(APPLE AND CMAKE_OSX_ARCHITECTURES STREQUAL "ppc64")
        set(ARCH "ppc64")
        set(ARCH_PPC64 ON)
        if(${OQS_DIST_BUILD})
            set(OQS_DIST_PPC64_BUILD ON)
        endif()
    else()
        set(ARCH "ppc")
        set(ARCH_PPC ON)
        if(${OQS_DIST_BUILD})
            set(OQS_DIST_PPC_BUILD ON)
        endif()
    endif()
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "s390x")
    set(ARCH "s390x")
    set(ARCH_S390X ON)
    if(${OQS_DIST_BUILD})
        set(OQS_DIST_S390X_BUILD ON)
    endif()
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "riscv")
    set(ARCH "riscv")
elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "loongarch64")
    set(ARCH "loongarch64")
    set(ARCH_LOONGARCH64 ON)
    if(${OQS_DIST_BUILD})
        set(OQS_DIST_LOONGARCH64_BUILD ON)
    endif()
elseif(OQS_PERMIT_UNSUPPORTED_ARCHITECTURE)
    message(WARNING "Unknown or unsupported processor: " ${CMAKE_SYSTEM_PROCESSOR})
    message(WARNING "Compilation on an unsupported processor should only be used for testing, as it may result an insecure configuration, for example due to variable-time instructions leaking secret information.")
else()
    message(FATAL_ERROR "Unknown or unsupported processor: " ${CMAKE_SYSTEM_PROCESSOR} ". Override by setting OQS_PERMIT_UNSUPPORTED_ARCHITECTURE=ON")
endif()

if(${OQS_USE_CUPQC})
    # CMAKE's CUDA language requires CMAKE 3.18
    cmake_minimum_required (VERSION 3.18)
    enable_language(CUDA)
    if(NOT DEFINED CMAKE_CUDA_ARCHITECTURES)
      set(CMAKE_CUDA_ARCHITECTURES 80 90)
    endif()
    find_package(cuPQC 0.2.0 REQUIRED)
endif()

if(OQS_USE_ICICLE)
    enable_language(CXX)
    set(CMAKE_CXX_STANDARD 17)
    set(CMAKE_CXX_STANDARD_REQUIRED ON)

    find_package(icicle_pqc_package REQUIRED)
endif()


if (NOT ((CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin") AND (ARCH_X86_64 STREQUAL "ON")) AND (OQS_LIBJADE_BUILD STREQUAL "ON"))
    message(FATAL_ERROR "Building liboqs with libjade implementations from libjade is only supported on Linux and Darwin on x86_64.")
endif()

# intentionally don't switch to variables to avoid --warn-uninitialized report
if(OQS_USE_CPU_EXTENSIONS)
    message(FATAL_ERROR "OQS_USE_CPU_EXTENSIONS is deprecated")
endif()

# intentionally don't switch to variables to avoid --warn-uninitialized report
if(OQS_PORTABLE_BUILD)
    message(FATAL_ERROR "OQS_PORTABLE_BUILD is deprecated")
endif()

if(CMAKE_BUILD_TYPE STREQUAL "Debug" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
    set(OQS_DEBUG_BUILD ON)
else()
    set(OQS_DEBUG_BUILD OFF)
endif()

option(OQS_SPEED_USE_ARM_PMU "Use ARM Performance Monitor Unit during benchmarking" OFF)

if(WIN32 AND NOT (MINGW OR MSYS OR CYGWIN))
    set(CMAKE_GENERATOR_CC cl)
endif()

include(.CMake/compiler_opts.cmake)
include(.CMake/alg_support.cmake)

if(${OQS_USE_OPENSSL})
    if(NOT DEFINED OPENSSL_ROOT_DIR)
        if(${CMAKE_HOST_SYSTEM_NAME} STREQUAL "Darwin")
            if(EXISTS "/usr/local/opt/openssl@1.1")
                set(OPENSSL_ROOT_DIR "/usr/local/opt/openssl@1.1")
            elseif(EXISTS "/opt/homebrew/opt/openssl@1.1")
                set(OPENSSL_ROOT_DIR "/opt/homebrew/opt/openssl@1.1")
            endif()
        endif()
    endif()
    find_package(OpenSSL 1.1.1 REQUIRED)

    if(OQS_DLOPEN_OPENSSL)
      find_program(OBJDUMP objdump)
      if(NOT OBJDUMP)
	message(FATAL_ERROR "objdump not found. Please install it from binutils.")
      endif()
      execute_process(
	COMMAND ${OBJDUMP} -p ${OPENSSL_CRYPTO_LIBRARY}
	COMMAND sed -n "s/[ 	]\\{1,\\}SONAME[ 	]\\{1,\\}//p"
	OUTPUT_VARIABLE OQS_OPENSSL_CRYPTO_SONAME
	OUTPUT_STRIP_TRAILING_WHITESPACE
	COMMAND_ERROR_IS_FATAL ANY)
      message(STATUS "OpenSSL dlopen SONAME: " ${OQS_OPENSSL_CRYPTO_SONAME})
    endif()
endif()

set(PUBLIC_HEADERS ${PROJECT_SOURCE_DIR}/src/oqs.h
                   ${PROJECT_SOURCE_DIR}/src/common/aes/aes_ops.h
                   ${PROJECT_SOURCE_DIR}/src/common/common.h
                   ${PROJECT_SOURCE_DIR}/src/common/rand/rand.h
                   ${PROJECT_SOURCE_DIR}/src/common/sha2/sha2_ops.h
                   ${PROJECT_SOURCE_DIR}/src/common/sha3/sha3_ops.h
                   ${PROJECT_SOURCE_DIR}/src/common/sha3/sha3x4_ops.h
                   ${PROJECT_SOURCE_DIR}/src/kem/kem.h
                   ${PROJECT_SOURCE_DIR}/src/sig/sig.h
                   ${PROJECT_SOURCE_DIR}/src/sig_stfl/sig_stfl.h)

set(INTERNAL_HEADERS ${PROJECT_SOURCE_DIR}/src/common/aes/aes.h
                     ${PROJECT_SOURCE_DIR}/src/common/rand/rand_nist.h
                     ${PROJECT_SOURCE_DIR}/src/common/sha2/sha2.h
                     ${PROJECT_SOURCE_DIR}/src/common/sha3/sha3.h
                     ${PROJECT_SOURCE_DIR}/src/common/sha3/sha3x4.h)

if(${OQS_ENABLE_KEM_BIKE})
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/kem/bike/kem_bike.h)
endif()
if(${OQS_ENABLE_KEM_FRODOKEM})
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/kem/frodokem/kem_frodokem.h)
endif()
if(OQS_ENABLE_KEM_NTRUPRIME)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/kem/ntruprime/kem_ntruprime.h)
endif()
if(OQS_ENABLE_KEM_NTRU)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/kem/ntru/kem_ntru.h)
endif()
##### OQS_COPY_FROM_UPSTREAM_FRAGMENT_INCLUDE_HEADERS_START
if(OQS_ENABLE_KEM_CLASSIC_MCELIECE)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/kem/classic_mceliece/kem_classic_mceliece.h)
endif()
if(OQS_ENABLE_KEM_HQC)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/kem/hqc/kem_hqc.h)
endif()
if(OQS_ENABLE_KEM_KYBER)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/kem/kyber/kem_kyber.h)
endif()
if(OQS_ENABLE_KEM_ML_KEM)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/kem/ml_kem/kem_ml_kem.h)
endif()
if(OQS_ENABLE_SIG_ML_DSA)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/sig/ml_dsa/sig_ml_dsa.h)
endif()
if(OQS_ENABLE_SIG_FALCON)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/sig/falcon/sig_falcon.h)
endif()
if(OQS_ENABLE_SIG_SPHINCS)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/sig/sphincs/sig_sphincs.h)
endif()
if(OQS_ENABLE_SIG_MAYO)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/sig/mayo/sig_mayo.h)
endif()
if(OQS_ENABLE_SIG_CROSS)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/sig/cross/sig_cross.h)
endif()
if(OQS_ENABLE_SIG_UOV)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/sig/uov/sig_uov.h)
endif()
if(OQS_ENABLE_SIG_SNOVA)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/sig/snova/sig_snova.h)
endif()
##### OQS_COPY_FROM_UPSTREAM_FRAGMENT_INCLUDE_HEADERS_END
if(OQS_ENABLE_SIG_SLH_DSA)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/sig/slh_dsa/sig_slh_dsa.h)
endif()
if(OQS_ENABLE_SIG_STFL_XMSS)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/sig_stfl/xmss/sig_stfl_xmss.h)
endif()
if(OQS_ENABLE_SIG_STFL_LMS)
    set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_SOURCE_DIR}/src/sig_stfl/lms/sig_stfl_lms.h)
endif()
execute_process(COMMAND ${CMAKE_COMMAND} -E make_directory ${PROJECT_BINARY_DIR}/include/oqs)
execute_process(COMMAND ${CMAKE_COMMAND} -E copy ${PUBLIC_HEADERS} ${PROJECT_BINARY_DIR}/include/oqs)
execute_process(COMMAND ${CMAKE_COMMAND} -E copy ${INTERNAL_HEADERS} ${PROJECT_BINARY_DIR}/include/oqs)
configure_file(src/oqsconfig.h.cmake ${PROJECT_BINARY_DIR}/include/oqs/oqsconfig.h)
set(PUBLIC_HEADERS ${PUBLIC_HEADERS} ${PROJECT_BINARY_DIR}/include/oqs/oqsconfig.h)

include_directories(${PROJECT_BINARY_DIR}/include)
add_subdirectory(src)

=== src/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

add_subdirectory(common)

# initialize KEM|SIG_OBJS for --warn-uninitialized
set(KEM_OBJS "")
set(SIG_OBJS "")
set(SIG_STFL_OBJS "")

if(${OQS_ENABLE_KEM_BIKE})
    add_subdirectory(kem/bike)
    set(KEM_OBJS ${KEM_OBJS} ${BIKE_OBJS})
endif()
if(${OQS_ENABLE_KEM_FRODOKEM})
    add_subdirectory(kem/frodokem)
    set(KEM_OBJS ${KEM_OBJS} ${FRODOKEM_OBJS})
endif()
if(OQS_ENABLE_KEM_NTRUPRIME)
    add_subdirectory(kem/ntruprime)
    set(KEM_OBJS ${KEM_OBJS} ${NTRUPRIME_OBJS})
endif()
if(OQS_ENABLE_KEM_NTRU)
    add_subdirectory(kem/ntru)
    set(KEM_OBJS ${KEM_OBJS} ${NTRU_OBJS})
endif()
##### OQS_COPY_FROM_UPSTREAM_FRAGMENT_ADD_ALG_OBJECTS_START
if(OQS_ENABLE_KEM_CLASSIC_MCELIECE)
    add_subdirectory(kem/classic_mceliece)
    set(KEM_OBJS ${KEM_OBJS} ${CLASSIC_MCELIECE_OBJS})
endif()
if(OQS_ENABLE_KEM_HQC)
    add_subdirectory(kem/hqc)
    set(KEM_OBJS ${KEM_OBJS} ${HQC_OBJS})
endif()
if(OQS_ENABLE_KEM_KYBER)
    add_subdirectory(kem/kyber)
    set(KEM_OBJS ${KEM_OBJS} ${KYBER_OBJS})
endif()
if(OQS_ENABLE_KEM_ML_KEM)
    add_subdirectory(kem/ml_kem)
    set(KEM_OBJS ${KEM_OBJS} ${ML_KEM_OBJS})
endif()
if(OQS_ENABLE_SIG_ML_DSA)
    add_subdirectory(sig/ml_dsa)
    set(SIG_OBJS ${SIG_OBJS} ${ML_DSA_OBJS})
endif()
if(OQS_ENABLE_SIG_FALCON)
    add_subdirectory(sig/falcon)
    set(SIG_OBJS ${SIG_OBJS} ${FALCON_OBJS})
endif()
if(OQS_ENABLE_SIG_SPHINCS)
    add_subdirectory(sig/sphincs)
    set(SIG_OBJS ${SIG_OBJS} ${SPHINCS_OBJS})
endif()
if(OQS_ENABLE_SIG_MAYO)
    add_subdirectory(sig/mayo)
    set(SIG_OBJS ${SIG_OBJS} ${MAYO_OBJS})
endif()
if(OQS_ENABLE_SIG_CROSS)
    add_subdirectory(sig/cross)
    set(SIG_OBJS ${SIG_OBJS} ${CROSS_OBJS})
endif()
if(OQS_ENABLE_SIG_UOV)
    add_subdirectory(sig/uov)
    set(SIG_OBJS ${SIG_OBJS} ${UOV_OBJS})
endif()
if(OQS_ENABLE_SIG_SNOVA)
    add_subdirectory(sig/snova)
    set(SIG_OBJS ${SIG_OBJS} ${SNOVA_OBJS})
endif()
##### OQS_COPY_FROM_UPSTREAM_FRAGMENT_ADD_ALG_OBJECTS_END

if(OQS_ENABLE_SIG_SLH_DSA)
    add_subdirectory(sig/slh_dsa)
    set(SIG_OBJS ${SIG_OBJS} ${SLH_DSA_OBJS})
endif()

if(OQS_ENABLE_SIG_STFL_XMSS)
    add_subdirectory(sig_stfl/xmss)
    set(SIG_STFL_OBJS ${SIG_STFL_OBJS} ${XMSS_OBJS})
endif()

if(OQS_ENABLE_SIG_STFL_LMS)
    add_subdirectory(sig_stfl/lms)
    set(SIG_STFL_OBJS ${SIG_STFL_OBJS} ${LMS_OBJS})
endif()

add_library(oqs kem/kem.c
                ${KEM_OBJS}
                sig/sig.c
                ${SIG_OBJS}
                sig_stfl/sig_stfl.c
                ${SIG_STFL_OBJS}
                ${COMMON_OBJS})

# Internal library to be used only by test programs
add_library(oqs-internal STATIC ${INTERNAL_OBJS})

if(DEFINED SANITIZER_LD_FLAGS)
    target_link_libraries(oqs PUBLIC ${SANITIZER_LD_FLAGS})
    target_link_libraries(oqs-internal PUBLIC ${SANITIZER_LD_FLAGS})
endif()
if(${OQS_USE_OPENSSL})
  if(${OQS_DLOPEN_OPENSSL})
    target_link_libraries(oqs PRIVATE ${CMAKE_DL_LIBS})
    target_link_libraries(oqs-internal PRIVATE ${CMAKE_DL_LIBS})
  else()
    target_link_libraries(oqs PRIVATE ${OPENSSL_CRYPTO_LIBRARY})
    target_link_libraries(oqs-internal PRIVATE ${OPENSSL_CRYPTO_LIBRARY})
  endif()
endif()
if(${OQS_USE_CUPQC})
    set_property(TARGET oqs PROPERTY CUDA_RESOLVE_DEVICE_SYMBOLS ON)
    target_link_libraries(oqs PRIVATE cupqc)
    target_link_options(oqs PRIVATE $<DEVICE_LINK: -dlto>)
endif()
if(${OQS_USE_ICICLE})
    target_link_libraries(oqs PRIVATE icicle::icicle_pqc_package)
endif()

target_include_directories(oqs
                           PUBLIC
                           "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
                           "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
)

target_include_directories(oqs-internal
                           PUBLIC
                           "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
                           "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
)

if(MINGW)
    target_link_options(oqs-internal PRIVATE -Wl,--export-all-symbols)
endif()

set_target_properties(oqs
    PROPERTIES
    ARCHIVE_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib"
    LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib"
    VERSION ${OQS_VERSION_TEXT}
    SOVERSION 9
    # For Windows DLLs
    RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bin")

set_target_properties(oqs-internal
    PROPERTIES
    C_VISIBILITY_PRESET default
    ARCHIVE_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib"
    LIBRARY_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/lib"
    # For Windows DLLs
    RUNTIME_OUTPUT_DIRECTORY "${PROJECT_BINARY_DIR}/bin")

configure_package_config_file(${CMAKE_CURRENT_SOURCE_DIR}/Config.cmake.in
  "${CMAKE_CURRENT_BINARY_DIR}/liboqsConfig.cmake"
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/liboqs
)

# generate the version file for the config file
write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/liboqsConfigVersion.cmake"
  VERSION "${OQS_VERSION_TEXT}"
  COMPATIBILITY AnyNewerVersion
)

if(OQS_USE_OPENSSL)
    set(_oqs_pkgconfig_requires_private openssl)
endif()

# generate pkg-config file
configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/liboqs.pc.in
  ${CMAKE_CURRENT_BINARY_DIR}/liboqs.pc
  @ONLY
)

install(FILES
          "${CMAKE_CURRENT_BINARY_DIR}/liboqsConfig.cmake"
          "${CMAKE_CURRENT_BINARY_DIR}/liboqsConfigVersion.cmake"
        DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/liboqs"
)

install(FILES
          "${CMAKE_CURRENT_BINARY_DIR}/liboqs.pc"
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

install(TARGETS oqs
        EXPORT liboqsTargets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/oqs
)

install(EXPORT liboqsTargets
        FILE liboqsTargets.cmake
        NAMESPACE OQS::
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/liboqs
)

install(FILES ${PUBLIC_HEADERS}
        DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/oqs)

export(EXPORT liboqsTargets
       FILE "${CMAKE_CURRENT_BINARY_DIR}/liboqsTargets.cmake"
       NAMESPACE OQS::
)

=== zephyr/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

# Only add liboqs Zephyr module if enabled in Kconfig
if(CONFIG_LIBOQS)

        # Workarounds for Zephyr
        if(CMAKE_SYSTEM_PROCESSOR STREQUAL "arm")
                # Workaround as the generic name "arm" is not a supported architecture in liboqs.
                # In Zephyr, however, it is exclusively used for 32-bit ARM architectures.
                set(CMAKE_SYSTEM_PROCESSOR "armv7")
        elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "riscv")
                # Zephyr doesn't distinguish between 32-bit and 64-bit RISC-V architectures.
                if(CONFIG_64BIT)
                        set(CMAKE_SYSTEM_PROCESSOR "riscv64")
                else()
                        set(CMAKE_SYSTEM_PROCESSOR "riscv32")
                endif()
        elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "posix")
                # Workaround to enable the native Zephyr builds on the Linux host system.
                if(BOARD MATCHES "native_posix|native_sim")
                        set(CMAKE_SYSTEM_PROCESSOR ${CMAKE_HOST_SYSTEM_PROCESSOR})
                else()
                        message(FATAL_ERROR "Unsupported board ${BOARD} with posix architecture")
                endif()
        elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86")
                # Zephyr doesn't distinguish between 32-bit and 64-bit x86 architectures.
                if(CONFIG_64BIT)
                        set(CMAKE_SYSTEM_PROCESSOR "x86_64")
                endif()
        endif()

        # We have to set CMAKE_SIZEOF_VOID_P manually as CMake can't detect it properly in Zephyr
        if(CONFIG_64BIT)
                set(CMAKE_SIZEOF_VOID_P 8)
        else()
                set(CMAKE_SIZEOF_VOID_P 4)
        endif()

        # Configuration for liboqs
        set(OQS_DIST_BUILD  OFF)
        set(OQS_BUILD_ONLY_LIB ON)
        set(OQS_USE_OPENSSL OFF)
        set(OQS_EMBEDDED_BUILD ON)

        set(CMAKE_CROSSCOMPILING ON)

        # Disable features by hand, as CMake won't find them properly with Zephyr
        set(CMAKE_HAVE_GETENTROPY OFF)
        set(CMAKE_HAVE_ALIGNED_ALLOC OFF)
        set(CMAKE_HAVE_POSIX_MEMALIGN OFF)
        set(CMAKE_HAVE_MEMALIGN OFF)
        set(CMAKE_HAVE_EXPLICIT_BZERO OFF)
        set(CMAKE_HAVE_MEMSET_S OFF)
        set(CC_SUPPORTS_WA_NOEXECSTACK OFF)
        set(LD_SUPPORTS_WL_Z_NOEXECSTACK OFF)

        # Algorithm selection (based on Kconfig)
        if(CONFIG_LIBOQS_ENABLE_KEM_BIKE)
                set(OQS_ENABLE_KEM_BIKE ON)
        else()
                set(OQS_ENABLE_KEM_BIKE OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_KEM_FRODOKEM)
                set(OQS_ENABLE_KEM_FRODOKEM ON)
        else()
                set(OQS_ENABLE_KEM_FRODOKEM OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_KEM_NTRUPRIME)
                set(OQS_ENABLE_KEM_NTRUPRIME ON)
        else()
                set(OQS_ENABLE_KEM_NTRUPRIME OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_KEM_CLASSIC_MCELIECE)
                set(OQS_ENABLE_KEM_CLASSIC_MCELIECE ON)
        else()
                set(OQS_ENABLE_KEM_CLASSIC_MCELIECE OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_KEM_HQC)
                set(OQS_ENABLE_KEM_HQC ON)
        else()
                set(OQS_ENABLE_KEM_HQC OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_KEM_KYBER)
                set(OQS_ENABLE_KEM_KYBER ON)
        else()
                set(OQS_ENABLE_KEM_KYBER OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_KEM_ML_KEM)
                set(OQS_ENABLE_KEM_ML_KEM ON)
        else()
                set(OQS_ENABLE_KEM_ML_KEM OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_SIG_ML_DSA)
                set(OQS_ENABLE_SIG_ML_DSA ON)
        else()
                set(OQS_ENABLE_SIG_ML_DSA OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_SIG_FALCON)
                set(OQS_ENABLE_SIG_FALCON ON)
        else()
                set(OQS_ENABLE_SIG_FALCON OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_SIG_SPHINCS)
                set(OQS_ENABLE_SIG_SPHINCS ON)
        else()
                set(OQS_ENABLE_SIG_SPHINCS OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_SIG_MAYO)
                set(OQS_ENABLE_SIG_MAYO ON)
                set(OQS_ENABLE_SIG_mayo_5 OFF)
        else()  
                set(OQS_ENABLE_SIG_MAYO OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_SIG_UOV)
                set(OQS_ENABLE_SIG_UOV ON)
        else()  
                set(OQS_ENABLE_SIG_UOV OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_SIG_CROSS)
                set(OQS_ENABLE_SIG_CROSS ON)
                # Disable CROSS variants with large stack usage
                set(OQS_ENABLE_SIG_cross_rsdp_128_small OFF)
                set(OQS_ENABLE_SIG_cross_rsdp_192_small OFF)
                set(OQS_ENABLE_SIG_cross_rsdp_256_balanced OFF)
                set(OQS_ENABLE_SIG_cross_rsdp_256_small OFF)
                set(OQS_ENABLE_SIG_cross_rsdpg_192_small OFF)
                set(OQS_ENABLE_SIG_cross_rsdpg_256_small OFF)
        else()  
                set(OQS_ENABLE_SIG_CROSS OFF)
        endif()

        if(CONFIG_LIBOQS_ENABLE_SIG_SNOVA)
                set(OQS_ENABLE_SIG_SNOVA ON)
                set(OQS_ENABLE_SIG_snova_SNOVA_56_25_2 OFF)
                set(OQS_ENABLE_SIG_snova_SNOVA_49_11_3 OFF)
                set(OQS_ENABLE_SIG_snova_SNOVA_37_8_4 OFF)
                set(OQS_ENABLE_SIG_snova_SNOVA_60_10_4 OFF)
                set(OQS_ENABLE_SIG_snova_SNOVA_24_5_5 OFF)
                set(OQS_ENABLE_SIG_snova_SNOVA_29_6_5 OFF)
        else()
                set(OQS_ENABLE_SIG_SNOVA OFF)
        endif()

        # Add the actual liboqs targets
        add_subdirectory(.. build)

        # Add target specific options to all liboqs targets
        zephyr_get_targets(.. "STATIC_LIBRARY;OBJECT_LIBRARY" ALL_TARGETS)
        foreach(target ${ALL_TARGETS})
                # Zephyr include directories
                target_include_directories(${target} PRIVATE
                        $<TARGET_PROPERTY:zephyr_interface,INTERFACE_INCLUDE_DIRECTORIES>
                )

                # Zephyr system include directories
                target_include_directories(${target} SYSTEM PRIVATE
                        $<TARGET_PROPERTY:zephyr_interface,INTERFACE_SYSTEM_INCLUDE_DIRECTORIES>
                )

                # Definitions
                target_compile_definitions(${target} PRIVATE
                        $<TARGET_PROPERTY:zephyr_interface,INTERFACE_COMPILE_DEFINITIONS>
                )

                # Compile options (includes compiler flags)
                target_compile_options(${target} PRIVATE
                        $<TARGET_PROPERTY:zephyr_interface,INTERFACE_COMPILE_OPTIONS>
                        $<TARGET_PROPERTY:compiler,no_builtin>
                )

                # liboqs depends on unistd.h, which ultimately needs the generated syscall_list.h file,
                # which is generated as part of ${SYSCALL_LIST_H_TARGET} target. Therefore, we have to
                # make sure that target is built before liboqs.
                add_dependencies(${target} ${SYSCALL_LIST_H_TARGET})

                # We don't want position independent code
                set_target_properties(${target} PROPERTIES POSITION_INDEPENDENT_CODE OFF)
        endforeach()

        # Link the liboqs library
        zephyr_link_libraries(oqs)

        # Include the liboqs headers
        zephyr_include_directories(${CMAKE_CURRENT_BINARY_DIR}/build/include)

        # Undo the Zephyr workarounds from above to not interfere with other modules
        if(CMAKE_SYSTEM_PROCESSOR STREQUAL "armv7")
                set(CMAKE_SYSTEM_PROCESSOR "arm")
        elseif(CMAKE_SYSTEM_PROCESSOR EQUAL CMAKE_HOST_SYSTEM_PROCESSOR)
                set(CMAKE_SYSTEM_PROCESSOR "posix")
        elseif(CMAKE_SYSTEM_PROCESSOR MATCHES "riscv")
                set(CMAKE_SYSTEM_PROCESSOR "riscv")
        elseif(CMAKE_SYSTEM_PROCESSOR STREQUAL "x86_64")
                set(CMAKE_SYSTEM_PROCESSOR "x86")
        endif()
endif()

=== .github/workflows/requirements.txt ===
#
# This file is autogenerated by pip-compile with Python 3.12
# by the following command:
#
#    pip-compile --generate-hashes --output-file=requirements.txt requirements.in
#
certifi==2025.6.15 \
    --hash=sha256:2e0c7ce7cb5d8f8634ca55d2ba7e6ec2689a2fd6537d8dec1296a477a4910057 \
    --hash=sha256:d747aa5a8b9bbbb1bb8c22bb13e22bd1f18e9796defa16bab421f7f7a317323b
    # via requests
charset-normalizer==3.4.2 \
    --hash=sha256:005fa3432484527f9732ebd315da8da8001593e2cf46a3d817669f062c3d9ed4 \
    --hash=sha256:046595208aae0120559a67693ecc65dd75d46f7bf687f159127046628178dc45 \
    --hash=sha256:0c29de6a1a95f24b9a1aa7aefd27d2487263f00dfd55a77719b530788f75cff7 \
    --hash=sha256:0c8c57f84ccfc871a48a47321cfa49ae1df56cd1d965a09abe84066f6853b9c0 \
    --hash=sha256:0f5d9ed7f254402c9e7d35d2f5972c9bbea9040e99cd2861bd77dc68263277c7 \
    --hash=sha256:18dd2e350387c87dabe711b86f83c9c78af772c748904d372ade190b5c7c9d4d \
    --hash=sha256:1b1bde144d98e446b056ef98e59c256e9294f6b74d7af6846bf5ffdafd687a7d \
    --hash=sha256:1c95a1e2902a8b722868587c0e1184ad5c55631de5afc0eb96bc4b0d738092c0 \
    --hash=sha256:1cad5f45b3146325bb38d6855642f6fd609c3f7cad4dbaf75549bf3b904d3184 \
    --hash=sha256:21b2899062867b0e1fde9b724f8aecb1af14f2778d69aacd1a5a1853a597a5db \
    --hash=sha256:24498ba8ed6c2e0b56d4acbf83f2d989720a93b41d712ebd4f4979660db4417b \
    --hash=sha256:25a23ea5c7edc53e0f29bae2c44fcb5a1aa10591aae107f2a2b2583a9c5cbc64 \
    --hash=sha256:289200a18fa698949d2b39c671c2cc7a24d44096784e76614899a7ccf2574b7b \
    --hash=sha256:28a1005facc94196e1fb3e82a3d442a9d9110b8434fc1ded7a24a2983c9888d8 \
    --hash=sha256:32fc0341d72e0f73f80acb0a2c94216bd704f4f0bce10aedea38f30502b271ff \
    --hash=sha256:36b31da18b8890a76ec181c3cf44326bf2c48e36d393ca1b72b3f484113ea344 \
    --hash=sha256:3c21d4fca343c805a52c0c78edc01e3477f6dd1ad7c47653241cf2a206d4fc58 \
    --hash=sha256:3fddb7e2c84ac87ac3a947cb4e66d143ca5863ef48e4a5ecb83bd48619e4634e \
    --hash=sha256:43e0933a0eff183ee85833f341ec567c0980dae57c464d8a508e1b2ceb336471 \
    --hash=sha256:4a476b06fbcf359ad25d34a057b7219281286ae2477cc5ff5e3f70a246971148 \
    --hash=sha256:4e594135de17ab3866138f496755f302b72157d115086d100c3f19370839dd3a \
    --hash=sha256:50bf98d5e563b83cc29471fa114366e6806bc06bc7a25fd59641e41445327836 \
    --hash=sha256:5a9979887252a82fefd3d3ed2a8e3b937a7a809f65dcb1e068b090e165bbe99e \
    --hash=sha256:5baececa9ecba31eff645232d59845c07aa030f0c81ee70184a90d35099a0e63 \
    --hash=sha256:5bf4545e3b962767e5c06fe1738f951f77d27967cb2caa64c28be7c4563e162c \
    --hash=sha256:6333b3aa5a12c26b2a4d4e7335a28f1475e0e5e17d69d55141ee3cab736f66d1 \
    --hash=sha256:65c981bdbd3f57670af8b59777cbfae75364b483fa8a9f420f08094531d54a01 \
    --hash=sha256:68a328e5f55ec37c57f19ebb1fdc56a248db2e3e9ad769919a58672958e8f366 \
    --hash=sha256:6a0289e4589e8bdfef02a80478f1dfcb14f0ab696b5a00e1f4b8a14a307a3c58 \
    --hash=sha256:6b66f92b17849b85cad91259efc341dce9c1af48e2173bf38a85c6329f1033e5 \
    --hash=sha256:6c9379d65defcab82d07b2a9dfbfc2e95bc8fe0ebb1b176a3190230a3ef0e07c \
    --hash=sha256:6fc1f5b51fa4cecaa18f2bd7a003f3dd039dd615cd69a2afd6d3b19aed6775f2 \
    --hash=sha256:70f7172939fdf8790425ba31915bfbe8335030f05b9913d7ae00a87d4395620a \
    --hash=sha256:721c76e84fe669be19c5791da68232ca2e05ba5185575086e384352e2c309597 \
    --hash=sha256:7222ffd5e4de8e57e03ce2cef95a4c43c98fcb72ad86909abdfc2c17d227fc1b \
    --hash=sha256:75d10d37a47afee94919c4fab4c22b9bc2a8bf7d4f46f87363bcf0573f3ff4f5 \
    --hash=sha256:76af085e67e56c8816c3ccf256ebd136def2ed9654525348cfa744b6802b69eb \
    --hash=sha256:770cab594ecf99ae64c236bc9ee3439c3f46be49796e265ce0cc8bc17b10294f \
    --hash=sha256:7a6ab32f7210554a96cd9e33abe3ddd86732beeafc7a28e9955cdf22ffadbab0 \
    --hash=sha256:7c48ed483eb946e6c04ccbe02c6b4d1d48e51944b6db70f697e089c193404941 \
    --hash=sha256:7f56930ab0abd1c45cd15be65cc741c28b1c9a34876ce8c17a2fa107810c0af0 \
    --hash=sha256:8075c35cd58273fee266c58c0c9b670947c19df5fb98e7b66710e04ad4e9ff86 \
    --hash=sha256:8272b73e1c5603666618805fe821edba66892e2870058c94c53147602eab29c7 \
    --hash=sha256:82d8fd25b7f4675d0c47cf95b594d4e7b158aca33b76aa63d07186e13c0e0ab7 \
    --hash=sha256:844da2b5728b5ce0e32d863af26f32b5ce61bc4273a9c720a9f3aa9df73b1455 \
    --hash=sha256:8755483f3c00d6c9a77f490c17e6ab0c8729e39e6390328e42521ef175380ae6 \
    --hash=sha256:915f3849a011c1f593ab99092f3cecfcb4d65d8feb4a64cf1bf2d22074dc0ec4 \
    --hash=sha256:926ca93accd5d36ccdabd803392ddc3e03e6d4cd1cf17deff3b989ab8e9dbcf0 \
    --hash=sha256:982bb1e8b4ffda883b3d0a521e23abcd6fd17418f6d2c4118d257a10199c0ce3 \
    --hash=sha256:98f862da73774290f251b9df8d11161b6cf25b599a66baf087c1ffe340e9bfd1 \
    --hash=sha256:9cbfacf36cb0ec2897ce0ebc5d08ca44213af24265bd56eca54bee7923c48fd6 \
    --hash=sha256:a370b3e078e418187da8c3674eddb9d983ec09445c99a3a263c2011993522981 \
    --hash=sha256:a955b438e62efdf7e0b7b52a64dc5c3396e2634baa62471768a64bc2adb73d5c \
    --hash=sha256:aa6af9e7d59f9c12b33ae4e9450619cf2488e2bbe9b44030905877f0b2324980 \
    --hash=sha256:aa88ca0b1932e93f2d961bf3addbb2db902198dca337d88c89e1559e066e7645 \
    --hash=sha256:aaeeb6a479c7667fbe1099af9617c83aaca22182d6cf8c53966491a0f1b7ffb7 \
    --hash=sha256:aaf27faa992bfee0264dc1f03f4c75e9fcdda66a519db6b957a3f826e285cf12 \
    --hash=sha256:b2680962a4848b3c4f155dc2ee64505a9c57186d0d56b43123b17ca3de18f0fa \
    --hash=sha256:b2d318c11350e10662026ad0eb71bb51c7812fc8590825304ae0bdd4ac283acd \
    --hash=sha256:b33de11b92e9f75a2b545d6e9b6f37e398d86c3e9e9653c4864eb7e89c5773ef \
    --hash=sha256:b3daeac64d5b371dea99714f08ffc2c208522ec6b06fbc7866a450dd446f5c0f \
    --hash=sha256:be1e352acbe3c78727a16a455126d9ff83ea2dfdcbc83148d2982305a04714c2 \
    --hash=sha256:bee093bf902e1d8fc0ac143c88902c3dfc8941f7ea1d6a8dd2bcb786d33db03d \
    --hash=sha256:c72fbbe68c6f32f251bdc08b8611c7b3060612236e960ef848e0a517ddbe76c5 \
    --hash=sha256:c9e36a97bee9b86ef9a1cf7bb96747eb7a15c2f22bdb5b516434b00f2a599f02 \
    --hash=sha256:cddf7bd982eaa998934a91f69d182aec997c6c468898efe6679af88283b498d3 \
    --hash=sha256:cf713fe9a71ef6fd5adf7a79670135081cd4431c2943864757f0fa3a65b1fafd \
    --hash=sha256:d11b54acf878eef558599658b0ffca78138c8c3655cf4f3a4a673c437e67732e \
    --hash=sha256:d41c4d287cfc69060fa91cae9683eacffad989f1a10811995fa309df656ec214 \
    --hash=sha256:d524ba3f1581b35c03cb42beebab4a13e6cdad7b36246bd22541fa585a56cccd \
    --hash=sha256:daac4765328a919a805fa5e2720f3e94767abd632ae410a9062dff5412bae65a \
    --hash=sha256:db4c7bf0e07fc3b7d89ac2a5880a6a8062056801b83ff56d8464b70f65482b6c \
    --hash=sha256:dc7039885fa1baf9be153a0626e337aa7ec8bf96b0128605fb0d77788ddc1681 \
    --hash=sha256:dccab8d5fa1ef9bfba0590ecf4d46df048d18ffe3eec01eeb73a42e0d9e7a8ba \
    --hash=sha256:dedb8adb91d11846ee08bec4c8236c8549ac721c245678282dcb06b221aab59f \
    --hash=sha256:e45ba65510e2647721e35323d6ef54c7974959f6081b58d4ef5d87c60c84919a \
    --hash=sha256:e53efc7c7cee4c1e70661e2e112ca46a575f90ed9ae3fef200f2a25e954f4b28 \
    --hash=sha256:e635b87f01ebc977342e2697d05b56632f5f879a4f15955dfe8cef2448b51691 \
    --hash=sha256:e70e990b2137b29dc5564715de1e12701815dacc1d056308e2b17e9095372a82 \
    --hash=sha256:e8082b26888e2f8b36a042a58307d5b917ef2b1cacab921ad3323ef91901c71a \
    --hash=sha256:e8323a9b031aa0393768b87f04b4164a40037fb2a3c11ac06a03ffecd3618027 \
    --hash=sha256:e92fca20c46e9f5e1bb485887d074918b13543b1c2a1185e69bb8d17ab6236a7 \
    --hash=sha256:eb30abc20df9ab0814b5a2524f23d75dcf83cde762c161917a2b4b7b55b1e518 \
    --hash=sha256:eba9904b0f38a143592d9fc0e19e2df0fa2e41c3c3745554761c5f6447eedabf \
    --hash=sha256:ef8de666d6179b009dce7bcb2ad4c4a779f113f12caf8dc77f0162c29d20490b \
    --hash=sha256:efd387a49825780ff861998cd959767800d54f8308936b21025326de4b5a42b9 \
    --hash=sha256:f0aa37f3c979cf2546b73e8222bbfa3dc07a641585340179d768068e3455e544 \
    --hash=sha256:f4074c5a429281bf056ddd4c5d3b740ebca4d43ffffe2ef4bf4d2d05114299da \
    --hash=sha256:f69a27e45c43520f5487f27627059b64aaf160415589230992cec34c5e18a509 \
    --hash=sha256:fb707f3e15060adf5b7ada797624a6c6e0138e2a26baa089df64c68ee98e040f \
    --hash=sha256:fcbe676a55d7445b22c10967bceaaf0ee69407fbe0ece4d032b6eb8d4565982a \
    --hash=sha256:fdb20a30fe1175ecabed17cbf7812f7b804b8a315a25f24678bcdf120a90077f
    # via requests
colorama==0.4.6 \
    --hash=sha256:08695f5cb7ed6e0531a20572697297273c47b8cae5a63ffc6d6ed5c201be6e44 \
    --hash=sha256:4f1d9991f5acc0ca119f9d443620b77f9d6b33703e51011c16baf57afb285fc6
    # via -r requirements.in
execnet==2.1.1 \
    --hash=sha256:26dee51f1b80cebd6d0ca8e74dd8745419761d3bef34163928cbebbdc4749fdc \
    --hash=sha256:5189b52c6121c24feae288166ab41b32549c7e2348652736540b9e6e7d4e72e3
    # via
    #   -r requirements.in
    #   pytest-xdist
idna==3.10 \
    --hash=sha256:12f65c9b470abda6dc35cf8e63cc574b1c52b11df2c86030af0ac09b01b13ea9 \
    --hash=sha256:946d195a0d259cbba61165e88e65941f16e9b36ea6ddb97f00452bae8b1287d3
    # via requests
iniconfig==2.0.0 \
    --hash=sha256:2d91e135bf72d31a410b17c16da610a82cb55f6b0477d1a902134b24a455b8b3 \
    --hash=sha256:b6a85871a79d2e3b22d2d1b94ac2824226a63c6b741c88f7ae975f18b6778374
    # via
    #   -r requirements.in
    #   pytest
packaging==24.0 \
    --hash=sha256:2ddfb553fdf02fb784c234c7ba6ccc288296ceabec964ad2eae3777778130bc5 \
    --hash=sha256:eb82c5e3e56209074766e6885bb04b8c38a0c015d0a30036ebe7ece34c9989e9
    # via
    #   -r requirements.in
    #   pytest
pluggy==1.4.0 \
    --hash=sha256:7db9f7b503d67d1c5b95f59773ebb58a8c1c288129a88665838012cfb07b8981 \
    --hash=sha256:8c85c2876142a764e5b7548e7d9a0e0ddb46f5185161049a79b7e974454223be
    # via
    #   -r requirements.in
    #   pytest
pytest==8.1.1 \
    --hash=sha256:2a8386cfc11fa9d2c50ee7b2a57e7d898ef90470a7a34c4b949ff59662bb78b7 \
    --hash=sha256:ac978141a75948948817d360297b7aae0fcb9d6ff6bc9ec6d514b85d5a65c044
    # via
    #   -r requirements.in
    #   pytest-xdist
pytest-xdist==3.5.0 \
    --hash=sha256:cbb36f3d67e0c478baa57fa4edc8843887e0f6cfc42d677530a36d7472b32d8a \
    --hash=sha256:d075629c7e00b611df89f490a5063944bee7a4362a5ff11c7cc7824a03dfce24
    # via -r requirements.in
pyyaml==6.0.1 \
    --hash=sha256:04ac92ad1925b2cff1db0cfebffb6ffc43457495c9b3c39d3fcae417d7125dc5 \
    --hash=sha256:062582fca9fabdd2c8b54a3ef1c978d786e0f6b3a1510e0ac93ef59e0ddae2bc \
    --hash=sha256:0d3304d8c0adc42be59c5f8a4d9e3d7379e6955ad754aa9d6ab7a398b59dd1df \
    --hash=sha256:1635fd110e8d85d55237ab316b5b011de701ea0f29d07611174a1b42f1444741 \
    --hash=sha256:184c5108a2aca3c5b3d3bf9395d50893a7ab82a38004c8f61c258d4428e80206 \
    --hash=sha256:18aeb1bf9a78867dc38b259769503436b7c72f7a1f1f4c93ff9a17de54319b27 \
    --hash=sha256:1d4c7e777c441b20e32f52bd377e0c409713e8bb1386e1099c2415f26e479595 \
    --hash=sha256:1e2722cc9fbb45d9b87631ac70924c11d3a401b2d7f410cc0e3bbf249f2dca62 \
    --hash=sha256:1fe35611261b29bd1de0070f0b2f47cb6ff71fa6595c077e42bd0c419fa27b98 \
    --hash=sha256:28c119d996beec18c05208a8bd78cbe4007878c6dd15091efb73a30e90539696 \
    --hash=sha256:326c013efe8048858a6d312ddd31d56e468118ad4cdeda36c719bf5bb6192290 \
    --hash=sha256:40df9b996c2b73138957fe23a16a4f0ba614f4c0efce1e9406a184b6d07fa3a9 \
    --hash=sha256:42f8152b8dbc4fe7d96729ec2b99c7097d656dc1213a3229ca5383f973a5ed6d \
    --hash=sha256:49a183be227561de579b4a36efbb21b3eab9651dd81b1858589f796549873dd6 \
    --hash=sha256:4fb147e7a67ef577a588a0e2c17b6db51dda102c71de36f8549b6816a96e1867 \
    --hash=sha256:50550eb667afee136e9a77d6dc71ae76a44df8b3e51e41b77f6de2932bfe0f47 \
    --hash=sha256:510c9deebc5c0225e8c96813043e62b680ba2f9c50a08d3724c7f28a747d1486 \
    --hash=sha256:5773183b6446b2c99bb77e77595dd486303b4faab2b086e7b17bc6bef28865f6 \
    --hash=sha256:596106435fa6ad000c2991a98fa58eeb8656ef2325d7e158344fb33864ed87e3 \
    --hash=sha256:6965a7bc3cf88e5a1c3bd2e0b5c22f8d677dc88a455344035f03399034eb3007 \
    --hash=sha256:69b023b2b4daa7548bcfbd4aa3da05b3a74b772db9e23b982788168117739938 \
    --hash=sha256:6c22bec3fbe2524cde73d7ada88f6566758a8f7227bfbf93a408a9d86bcc12a0 \

=== scripts/copy_from_upstream/requirements.txt ===
# This file was autogenerated by uv via the following command:
#    uv pip compile --generate-hashes requirements.in -o requirements.txt
attrs==25.3.0 \
    --hash=sha256:427318ce031701fea540783410126f03899a97ffc6f61596ad581ac2e40e3bc3 \
    --hash=sha256:75d7cefc7fb576747b2c81b4442d4d4a1ce0900973527c011d1030fd3bf4af1b
    # via -r requirements.in
certifi==2025.8.3 \
    --hash=sha256:e564105f78ded564e3ae7c923924435e1daa7463faeab5bb932bc53ffae63407 \
    --hash=sha256:f6c12493cfb1b06ba2ff328595af9350c65d6644968e5d3a2ffd78699af217a5
    # via requests
charset-normalizer==3.4.3 \
    --hash=sha256:00237675befef519d9af72169d8604a067d92755e84fe76492fef5441db05b91 \
    --hash=sha256:02425242e96bcf29a49711b0ca9f37e451da7c70562bc10e8ed992a5a7a25cc0 \
    --hash=sha256:027b776c26d38b7f15b26a5da1044f376455fb3766df8fc38563b4efbc515154 \
    --hash=sha256:07a0eae9e2787b586e129fdcbe1af6997f8d0e5abaa0bc98c0e20e124d67e601 \
    --hash=sha256:0cacf8f7297b0c4fcb74227692ca46b4a5852f8f4f24b3c766dd94a1075c4884 \
    --hash=sha256:0e78314bdc32fa80696f72fa16dc61168fda4d6a0c014e0380f9d02f0e5d8a07 \
    --hash=sha256:0f2be7e0cf7754b9a30eb01f4295cc3d4358a479843b31f328afd210e2c7598c \
    --hash=sha256:13faeacfe61784e2559e690fc53fa4c5ae97c6fcedb8eb6fb8d0a15b475d2c64 \
    --hash=sha256:14c2a87c65b351109f6abfc424cab3927b3bdece6f706e4d12faaf3d52ee5efe \
    --hash=sha256:1606f4a55c0fd363d754049cdf400175ee96c992b1f8018b993941f221221c5f \
    --hash=sha256:16a8770207946ac75703458e2c743631c79c59c5890c80011d536248f8eaa432 \
    --hash=sha256:18343b2d246dc6761a249ba1fb13f9ee9a2bcd95decc767319506056ea4ad4dc \
    --hash=sha256:18b97b8404387b96cdbd30ad660f6407799126d26a39ca65729162fd810a99aa \
    --hash=sha256:1bb60174149316da1c35fa5233681f7c0f9f514509b8e399ab70fea5f17e45c9 \
    --hash=sha256:1e8ac75d72fa3775e0b7cb7e4629cec13b7514d928d15ef8ea06bca03ef01cae \
    --hash=sha256:1ef99f0456d3d46a50945c98de1774da86f8e992ab5c77865ea8b8195341fc19 \
    --hash=sha256:2001a39612b241dae17b4687898843f254f8748b796a2e16f1051a17078d991d \
    --hash=sha256:23b6b24d74478dc833444cbd927c338349d6ae852ba53a0d02a2de1fce45b96e \
    --hash=sha256:252098c8c7a873e17dd696ed98bbe91dbacd571da4b87df3736768efa7a792e4 \
    --hash=sha256:257f26fed7d7ff59921b78244f3cd93ed2af1800ff048c33f624c87475819dd7 \
    --hash=sha256:2c322db9c8c89009a990ef07c3bcc9f011a3269bc06782f916cd3d9eed7c9312 \
    --hash=sha256:30a96e1e1f865f78b030d65241c1ee850cdf422d869e9028e2fc1d5e4db73b92 \
    --hash=sha256:30d006f98569de3459c2fc1f2acde170b7b2bd265dc1943e87e1a4efe1b67c31 \
    --hash=sha256:31a9a6f775f9bcd865d88ee350f0ffb0e25936a7f930ca98995c05abf1faf21c \
    --hash=sha256:320e8e66157cc4e247d9ddca8e21f427efc7a04bbd0ac8a9faf56583fa543f9f \
    --hash=sha256:34a7f768e3f985abdb42841e20e17b330ad3aaf4bb7e7aeeb73db2e70f077b99 \
    --hash=sha256:3653fad4fe3ed447a596ae8638b437f827234f01a8cd801842e43f3d0a6b281b \
    --hash=sha256:3cd35b7e8aedeb9e34c41385fda4f73ba609e561faedfae0a9e75e44ac558a15 \
    --hash=sha256:3cfb2aad70f2c6debfbcb717f23b7eb55febc0bb23dcffc0f076009da10c6392 \
    --hash=sha256:416175faf02e4b0810f1f38bcb54682878a4af94059a1cd63b8747244420801f \
    --hash=sha256:41d1fc408ff5fdfb910200ec0e74abc40387bccb3252f3f27c0676731df2b2c8 \
    --hash=sha256:42e5088973e56e31e4fa58eb6bd709e42fc03799c11c42929592889a2e54c491 \
    --hash=sha256:4ca4c094de7771a98d7fbd67d9e5dbf1eb73efa4f744a730437d8a3a5cf994f0 \
    --hash=sha256:511729f456829ef86ac41ca78c63a5cb55240ed23b4b737faca0eb1abb1c41bc \
    --hash=sha256:53cd68b185d98dde4ad8990e56a58dea83a4162161b1ea9272e5c9182ce415e0 \
    --hash=sha256:585f3b2a80fbd26b048a0be90c5aae8f06605d3c92615911c3a2b03a8a3b796f \
    --hash=sha256:5b413b0b1bfd94dbf4023ad6945889f374cd24e3f62de58d6bb102c4d9ae534a \
    --hash=sha256:5d8d01eac18c423815ed4f4a2ec3b439d654e55ee4ad610e153cf02faf67ea40 \
    --hash=sha256:6aab0f181c486f973bc7262a97f5aca3ee7e1437011ef0c2ec04b5a11d16c927 \
    --hash=sha256:6cf8fd4c04756b6b60146d98cd8a77d0cdae0e1ca20329da2ac85eed779b6849 \
    --hash=sha256:6fb70de56f1859a3f71261cbe41005f56a7842cc348d3aeb26237560bfa5e0ce \
    --hash=sha256:6fce4b8500244f6fcb71465d4a4930d132ba9ab8e71a7859e6a5d59851068d14 \
    --hash=sha256:70bfc5f2c318afece2f5838ea5e4c3febada0be750fcf4775641052bbba14d05 \
    --hash=sha256:73dc19b562516fc9bcf6e5d6e596df0b4eb98d87e4f79f3ae71840e6ed21361c \
    --hash=sha256:74d77e25adda8581ffc1c720f1c81ca082921329452eba58b16233ab1842141c \
    --hash=sha256:78deba4d8f9590fe4dae384aeff04082510a709957e968753ff3c48399f6f92a \
    --hash=sha256:86df271bf921c2ee3818f0522e9a5b8092ca2ad8b065ece5d7d9d0e9f4849bcc \
    --hash=sha256:88ab34806dea0671532d3f82d82b85e8fc23d7b2dd12fa837978dad9bb392a34 \
    --hash=sha256:8999f965f922ae054125286faf9f11bc6932184b93011d138925a1773830bbe9 \
    --hash=sha256:8dcfc373f888e4fb39a7bc57e93e3b845e7f462dacc008d9749568b1c4ece096 \
    --hash=sha256:939578d9d8fd4299220161fdd76e86c6a251987476f5243e8864a7844476ba14 \
    --hash=sha256:96b2b3d1a83ad55310de8c7b4a2d04d9277d5591f40761274856635acc5fcb30 \
    --hash=sha256:a2d08ac246bb48479170408d6c19f6385fa743e7157d716e144cad849b2dd94b \
    --hash=sha256:b256ee2e749283ef3ddcff51a675ff43798d92d746d1a6e4631bf8c707d22d0b \
    --hash=sha256:b5e3b2d152e74e100a9e9573837aba24aab611d39428ded46f4e4022ea7d1942 \
    --hash=sha256:b89bc04de1d83006373429975f8ef9e7932534b8cc9ca582e4db7d20d91816db \
    --hash=sha256:bd28b817ea8c70215401f657edef3a8aa83c29d447fb0b622c35403780ba11d5 \
    --hash=sha256:c60e092517a73c632ec38e290eba714e9627abe9d301c8c8a12ec32c314a2a4b \
    --hash=sha256:c6dbd0ccdda3a2ba7c2ecd9d77b37f3b5831687d8dc1b6ca5f56a4880cc7b7ce \
    --hash=sha256:c6e490913a46fa054e03699c70019ab869e990270597018cef1d8562132c2669 \
    --hash=sha256:c6f162aabe9a91a309510d74eeb6507fab5fff92337a15acbe77753d88d9dcf0 \
    --hash=sha256:c6fd51128a41297f5409deab284fecbe5305ebd7e5a1f959bee1c054622b7018 \
    --hash=sha256:cc34f233c9e71701040d772aa7490318673aa7164a0efe3172b2981218c26d93 \
    --hash=sha256:cc9370a2da1ac13f0153780040f465839e6cccb4a1e44810124b4e22483c93fe \
    --hash=sha256:ccf600859c183d70eb47e05a44cd80a4ce77394d1ac0f79dbd2dd90a69a3a049 \
    --hash=sha256:ce571ab16d890d23b5c278547ba694193a45011ff86a9162a71307ed9f86759a \
    --hash=sha256:cf1ebb7d78e1ad8ec2a8c4732c7be2e736f6e5123a4146c5b89c9d1f585f8cef \
    --hash=sha256:d0e909868420b7049dafd3a31d45125b31143eec59235311fc4c57ea26a4acd2 \
    --hash=sha256:d22dbedd33326a4a5190dd4fe9e9e693ef12160c77382d9e87919bce54f3d4ca \
    --hash=sha256:d716a916938e03231e86e43782ca7878fb602a125a91e7acb8b5112e2e96ac16 \
    --hash=sha256:d79c198e27580c8e958906f803e63cddb77653731be08851c7df0b1a14a8fc0f \
    --hash=sha256:d95bfb53c211b57198bb91c46dd5a2d8018b3af446583aab40074bf7988401cb \
    --hash=sha256:e28e334d3ff134e88989d90ba04b47d84382a828c061d0d1027b1b12a62b39b1 \
    --hash=sha256:ec557499516fc90fd374bf2e32349a2887a876fbf162c160e3c01b6849eaf557 \
    --hash=sha256:fb6fecfd65564f208cbf0fba07f107fb661bcd1a7c389edbced3f7a493f70e37 \
    --hash=sha256:fb731e5deb0c7ef82d698b0f4c5bb724633ee2a489401594c5c88b02e6cb15f7 \
    --hash=sha256:fb7f67a1bfa6e40b438170ebdc8158b78dc465a5a67b6dde178a46987b244a72 \
    --hash=sha256:fd10de089bcdcd1be95a2f73dbe6254798ec1bda9f450d5828c96f93e2536b9c \
    --hash=sha256:fdabf8315679312cfa71302f9bd509ded4f2f263fb5b765cf1433b39106c3cc9
    # via requests
gitdb==4.0.12 \
    --hash=sha256:5ef71f855d191a3326fcfbc0d5da835f26b13fbcba60c32c21091c349ffdb571 \
    --hash=sha256:67073e15955400952c6565cc3e707c554a4eea2e428946f7a4c162fab9bd9bcf
    # via gitpython
gitpython==3.1.45 \
    --hash=sha256:85b0ee964ceddf211c41b9f27a49086010a190fd8132a24e21f362a4b36a791c \
    --hash=sha256:8908cb2e02fb3b93b7eb0f2827125cb699869470432cc885f019b8fd0fccff77
    # via -r requirements.in
idna==3.10 \
    --hash=sha256:12f65c9b470abda6dc35cf8e63cc574b1c52b11df2c86030af0ac09b01b13ea9 \
    --hash=sha256:946d195a0d259cbba61165e88e65941f16e9b36ea6ddb97f00452bae8b1287d3
    # via requests
importlib-metadata==8.7.0 \
    --hash=sha256:d13b81ad223b890aa16c5471f2ac3056cf76c5f10f82d6f9292f0b415f389000 \
    --hash=sha256:e5dd1551894c77868a30651cef00984d50e1002d06942a7101d34870c5f02afd
    # via -r requirements.in
jinja2==3.1.6 \
    --hash=sha256:0137fb05990d35f1275a587e9aee6d56da821fc83491a0fb838183be43f66d6d \
    --hash=sha256:85ece4451f492d0c13c5dd7c13a64681a86afae63a5f347908daf103ce6d2f67
    # via -r requirements.in
markdown-it-py==3.0.0 \
    --hash=sha256:355216845c60bd96232cd8d8c40e8f9765cc86f46880e43a8fd22dc1a1a8cab1 \
    --hash=sha256:e3f60a94fa066dc52ec76661e37c851cb232d92f9886b15cb560aaada2df8feb
    # via
    #   -r requirements.in
    #   mdit-py-plugins
markupsafe==3.0.2 \
    --hash=sha256:0bff5e0ae4ef2e1ae4fdf2dfd5b76c75e5c2fa4132d05fc1b0dabcd20c7e28c4 \
    --hash=sha256:0f4ca02bea9a23221c0182836703cbf8930c5e9454bacce27e767509fa286a30 \
    --hash=sha256:1225beacc926f536dc82e45f8a4d68502949dc67eea90eab715dea3a21c1b5f0 \
    --hash=sha256:131a3c7689c85f5ad20f9f6fb1b866f402c445b220c19fe4308c0b147ccd2ad9 \
    --hash=sha256:15ab75ef81add55874e7ab7055e9c397312385bd9ced94920f2802310c930396 \
    --hash=sha256:1a9d3f5f0901fdec14d8d2f66ef7d035f2157240a433441719ac9a3fba440b13 \
    --hash=sha256:1c99d261bd2d5f6b59325c92c73df481e05e57f19837bdca8413b9eac4bd8028 \
    --hash=sha256:1e084f686b92e5b83186b07e8a17fc09e38fff551f3602b249881fec658d3eca \
    --hash=sha256:2181e67807fc2fa785d0592dc2d6206c019b9502410671cc905d132a92866557 \
    --hash=sha256:2cb8438c3cbb25e220c2ab33bb226559e7afb3baec11c4f218ffa7308603c832 \
    --hash=sha256:3169b1eefae027567d1ce6ee7cae382c57fe26e82775f460f0b2778beaad66c0 \
    --hash=sha256:3809ede931876f5b2ec92eef964286840ed3540dadf803dd570c3b7e13141a3b \
    --hash=sha256:38a9ef736c01fccdd6600705b09dc574584b89bea478200c5fbf112a6b0d5579 \
    --hash=sha256:3d79d162e7be8f996986c064d1c7c817f6df3a77fe3d6859f6f9e7be4b8c213a \
    --hash=sha256:444dcda765c8a838eaae23112db52f1efaf750daddb2d9ca300bcae1039adc5c \
    --hash=sha256:48032821bbdf20f5799ff537c7ac3d1fba0ba032cfc06194faffa8cda8b560ff \
    --hash=sha256:4aa4e5faecf353ed117801a068ebab7b7e09ffb6e1d5e412dc852e0da018126c \
    --hash=sha256:52305740fe773d09cffb16f8ed0427942901f00adedac82ec8b67752f58a1b22 \
    --hash=sha256:569511d3b58c8791ab4c2e1285575265991e6d8f8700c7be0e88f86cb0672094 \
    --hash=sha256:57cb5a3cf367aeb1d316576250f65edec5bb3be939e9247ae594b4bcbc317dfb \
    --hash=sha256:5b02fb34468b6aaa40dfc198d813a641e3a63b98c2b05a16b9f80b7ec314185e \
    --hash=sha256:6381026f158fdb7c72a168278597a5e3a5222e83ea18f543112b2662a9b699c5 \
    --hash=sha256:6af100e168aa82a50e186c82875a5893c5597a0c1ccdb0d8b40240b1f28b969a \
    --hash=sha256:6c89876f41da747c8d3677a2b540fb32ef5715f97b66eeb0c6b66f5e3ef6f59d \
    --hash=sha256:6e296a513ca3d94054c2c881cc913116e90fd030ad1c656b3869762b754f5f8a \
    --hash=sha256:70a87b411535ccad5ef2f1df5136506a10775d267e197e4cf531ced10537bd6b \
    --hash=sha256:7e94c425039cde14257288fd61dcfb01963e658efbc0ff54f5306b06054700f8 \
    --hash=sha256:846ade7b71e3536c4e56b386c2a47adf5741d2d8b94ec9dc3e92e5e1ee1e2225 \
    --hash=sha256:88416bd1e65dcea10bc7569faacb2c20ce071dd1f87539ca2ab364bf6231393c \
    --hash=sha256:88b49a3b9ff31e19998750c38e030fc7bb937398b1f78cfa599aaef92d693144 \
    --hash=sha256:8c4e8c3ce11e1f92f6536ff07154f9d49677ebaaafc32db9db4620bc11ed480f \
    --hash=sha256:8e06879fc22a25ca47312fbe7c8264eb0b662f6db27cb2d3bbbc74b1df4b9b87 \
    --hash=sha256:9025b4018f3a1314059769c7bf15441064b2207cb3f065e6ea1e7359cb46db9d \
    --hash=sha256:93335ca3812df2f366e80509ae119189886b0f3c2b81325d39efdb84a1e2ae93 \
    --hash=sha256:9778bd8ab0a994ebf6f84c2b949e65736d5575320a17ae8984a77fab08db94cf \
    --hash=sha256:9e2d922824181480953426608b81967de705c3cef4d1af983af849d7bd619158 \
    --hash=sha256:a123e330ef0853c6e822384873bef7507557d8e4a082961e1defa947aa59ba84 \
    --hash=sha256:a904af0a6162c73e3edcb969eeeb53a63ceeb5d8cf642fade7d39e7963a22ddb \
    --hash=sha256:ad10d3ded218f1039f11a75f8091880239651b52e9bb592ca27de44eed242a48 \

=== src/common/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

include(CheckSymbolExists)

# initialize to avoid --warn-uninitialized report
set(_COMMON_OBJS "")
set(_INTERNAL_OBJS "")

if(CMAKE_C_COMPILER_ID STREQUAL "GNU" OR
   CMAKE_C_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wbad-function-cast)
endif()
if(CMAKE_C_COMPILER_ID MATCHES "Clang")
    add_compile_options(-Wcast-qual)
    add_compile_options(-Wnarrowing)
    add_compile_options(-Wconversion)
endif()

set(OSSL_HELPERS "")

if(${OQS_USE_AES_OPENSSL})
    set(AES_IMPL aes/aes_ossl.c)
    set(OSSL_HELPERS ossl_helpers.c)
else()
   set(AES_IMPL aes/aes_impl.c aes/aes_c.c)
   if (OQS_DIST_X86_64_BUILD OR OQS_USE_AES_INSTRUCTIONS)
      set(AES_IMPL ${AES_IMPL} aes/aes128_ni.c)
      set(AES_IMPL ${AES_IMPL} aes/aes256_ni.c)
      if(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
        set_source_files_properties(aes/aes128_ni.c PROPERTIES COMPILE_FLAGS "")
        set_source_files_properties(aes/aes256_ni.c PROPERTIES COMPILE_FLAGS "")
      else()
        set_source_files_properties(aes/aes128_ni.c PROPERTIES COMPILE_FLAGS "-maes -mssse3")
        set_source_files_properties(aes/aes256_ni.c PROPERTIES COMPILE_FLAGS "-maes -mssse3")
      endif()
   elseif (OQS_DIST_ARM64_V8_BUILD)
      set(AES_IMPL ${AES_IMPL} aes/aes128_armv8.c)
      set(AES_IMPL ${AES_IMPL} aes/aes256_armv8.c)
      set_source_files_properties(aes/aes128_armv8.c PROPERTIES COMPILE_FLAGS -mcpu=cortex-a53+crypto)
      set_source_files_properties(aes/aes256_armv8.c PROPERTIES COMPILE_FLAGS -mcpu=cortex-a53+crypto)
   elseif (OQS_USE_ARM_AES_INSTRUCTIONS)
      set(AES_IMPL ${AES_IMPL} aes/aes128_armv8.c)
      set(AES_IMPL ${AES_IMPL} aes/aes256_armv8.c)
       if ((CMAKE_SYSTEM_NAME MATCHES "Darwin") AND (${CMAKE_C_COMPILER_ID} STREQUAL "GNU"))
         set_source_files_properties(aes/aes128_armv8.c PROPERTIES COMPILE_FLAGS -march=armv8-a+crypto)
         set_source_files_properties(aes/aes256_armv8.c PROPERTIES COMPILE_FLAGS -march=armv8-a+crypto)
       endif()
   endif()
endif()

if(${OQS_USE_SHA2_OPENSSL})
    set(SHA2_IMPL sha2/sha2_ossl.c)
    set(OSSL_HELPERS ossl_helpers.c)
else()
    set(SHA2_IMPL sha2/sha2_impl.c sha2/sha2_c.c)
    if (OQS_DIST_ARM64_V8_BUILD)
       set(SHA2_IMPL ${SHA2_IMPL} sha2/sha2_armv8.c)
       set_source_files_properties(sha2/sha2_armv8.c PROPERTIES COMPILE_FLAGS -mcpu=cortex-a53+crypto)
    elseif (OQS_USE_ARM_SHA2_INSTRUCTIONS)
       # Assume we are compiling native
       set(SHA2_IMPL ${SHA2_IMPL} sha2/sha2_armv8.c)
       if ((CMAKE_SYSTEM_NAME MATCHES "Darwin") AND (${CMAKE_C_COMPILER_ID} STREQUAL "GNU"))
         set_source_files_properties(sha2/sha2_armv8.c PROPERTIES COMPILE_FLAGS -march=armv8-a+crypto)
       endif()
    endif()
endif()

if(${OQS_USE_SHA3_OPENSSL})
    if (${OQS_ENABLE_SHA3_xkcp_low})
        add_subdirectory(sha3/xkcp_low)
    endif()
    set(SHA3_IMPL sha3/ossl_sha3.c sha3/ossl_sha3x4.c)
    set(OSSL_HELPERS ossl_helpers.c)
else() # using XKCP
    add_subdirectory(sha3/xkcp_low)
    set(SHA3_IMPL sha3/xkcp_sha3.c sha3/xkcp_sha3x4.c)
    if(OQS_USE_SHA3_AVX512VL)
      # also build avx512vl modules
      add_subdirectory(sha3/avx512vl_low)
      list(APPEND SHA3_IMPL sha3/avx512vl_sha3.c sha3/avx512vl_sha3x4.c)
    endif()
endif()

if ((OQS_LIBJADE_BUILD STREQUAL "ON"))
    set(LIBJADE_RANDOMBYTES libjade_shims/libjade_randombytes.c)
else()
    set(LIBJADE_RANDOMBYTES "")
endif()

add_library(common OBJECT ${AES_IMPL} aes/aes.c
                          ${SHA2_IMPL} sha2/sha2.c
                          ${SHA3_IMPL} sha3/sha3.c sha3/sha3x4.c
                          ${OSSL_HELPERS}
                          common.c
                          pqclean_shims/fips202.c
                          pqclean_shims/fips202x4.c
                          ${LIBJADE_RANDOMBYTES}
                          rand/rand.c)

# Implementations of the internal API to be exposed to test programs
add_library(internal OBJECT ${AES_IMPL} aes/aes.c
                            ${SHA2_IMPL} sha2/sha2.c
                            ${SHA3_IMPL} sha3/sha3.c sha3/sha3x4.c
                            ${OSSL_HELPERS}
                            common.c
                            rand/rand_nist.c)
set_property(TARGET internal PROPERTY C_VISIBILITY_PRESET default)

if(${OQS_USE_OPENSSL})
    target_include_directories(common PRIVATE ${OPENSSL_INCLUDE_DIR})
    target_include_directories(internal PRIVATE ${OPENSSL_INCLUDE_DIR})
else()
    if(WIN32 AND CMAKE_SYSTEM_VERSION)
      if(MSVC_VERSION GREATER 1500 AND NOT (CMAKE_SYSTEM_VERSION LESS 6.0))
        target_compile_definitions(common PRIVATE OQS_HAVE_BCRYPT)
        target_compile_definitions(internal PRIVATE OQS_HAVE_BCRYPT)
      endif()
    else()
      check_symbol_exists(getentropy "unistd.h" CMAKE_UNISTD_HAVE_GETENTROPY)
      check_symbol_exists(getentropy "sys/random.h" CMAKE_SYS_RANDOM_HAVE_GETENTROPY)
      if("${CMAKE_UNISTD_HAVE_GETENTROPY}" OR "${CMAKE_SYS_RANDOM_HAVE_GETENTROPY}")
          target_compile_definitions(common PRIVATE OQS_HAVE_GETENTROPY)
          target_compile_definitions(internal PRIVATE OQS_HAVE_GETENTROPY)
      endif()
    endif()
endif()
if(OQS_USE_PTHREADS)
    target_link_libraries(common PRIVATE Threads::Threads)
    target_link_libraries(internal PRIVATE Threads::Threads)
endif()

# check available functions to perform aligned mallocs
check_symbol_exists(aligned_alloc stdlib.h CMAKE_HAVE_ALIGNED_ALLOC)
check_symbol_exists(posix_memalign stdlib.h CMAKE_HAVE_POSIX_MEMALIGN)
check_symbol_exists(memalign malloc.h CMAKE_HAVE_MEMALIGN)

if(CMAKE_HAVE_ALIGNED_ALLOC)
    target_compile_definitions(common PRIVATE OQS_HAVE_ALIGNED_ALLOC)
    target_compile_definitions(internal PRIVATE OQS_HAVE_ALIGNED_ALLOC)
endif()

if(CMAKE_HAVE_POSIX_MEMALIGN)
    target_compile_definitions(common PRIVATE OQS_HAVE_POSIX_MEMALIGN)
    target_compile_definitions(internal PRIVATE OQS_HAVE_POSIX_MEMALIGN)
endif()

if(CMAKE_HAVE_MEMALIGN)
    target_compile_definitions(common PRIVATE OQS_HAVE_MEMALIGN)
    target_compile_definitions(internal PRIVATE OQS_HAVE_MEMALIGN)
endif()

# check if explicit_bzero, or explicit_memset exists or memset_s
check_symbol_exists(explicit_bzero string.h CMAKE_HAVE_EXPLICIT_BZERO)
check_symbol_exists(explicit_memset string.h CMAKE_HAVE_EXPLICIT_MEMSET)
check_symbol_exists(memset_s string.h CMAKE_HAVE_MEMSET_S)

if(CMAKE_HAVE_EXPLICIT_BZERO)
    target_compile_definitions(common PRIVATE OQS_HAVE_EXPLICIT_BZERO)
    target_compile_definitions(internal PRIVATE OQS_HAVE_EXPLICIT_BZERO)
endif()

if(CMAKE_HAVE_EXPLICIT_MEMSET)
    target_compile_definitions(common PRIVATE OQS_HAVE_EXPLICIT_MEMSET)
    target_compile_definitions(internal PRIVATE OQS_HAVE_EXPLICIT_MEMSET)
endif()

if(CMAKE_HAVE_MEMSET_S)
    target_compile_definitions(common PRIVATE OQS_HAVE_MEMSET_S)
    target_compile_definitions(internal PRIVATE OQS_HAVE_MEMSET_S)
endif()

if(${OQS_ENABLE_SHA3_xkcp_low}) # using XKCP
    set(_COMMON_OBJS ${_COMMON_OBJS} ${XKCP_LOW_OBJS})
    set(_INTERNAL_OBJS ${_INTERNAL_OBJS} ${XKCP_LOW_OBJS})
endif()

if(${OQS_USE_SHA3_AVX512VL})
    set(_COMMON_OBJS ${_COMMON_OBJS} ${SHA3_AVX512VL_LOW_OBJS})
    set(_INTERNAL_OBJS ${_INTERNAL_OBJS} ${SHA3_AVX512VL_LOW_OBJS})
endif()

set(_COMMON_OBJS ${_COMMON_OBJS} $<TARGET_OBJECTS:common>)
set(COMMON_OBJS ${_COMMON_OBJS} PARENT_SCOPE)
set(_INTERNAL_OBJS ${_INTERNAL_OBJS} $<TARGET_OBJECTS:internal>)
set(INTERNAL_OBJS ${_INTERNAL_OBJS} PARENT_SCOPE)

=== src/kem/ml_kem/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

# This file was generated by
# scripts/copy_from_upstream/copy_from_upstream.py

set(_ML_KEM_OBJS "")

if(OQS_ENABLE_KEM_ml_kem_512)
    add_library(ml_kem_512_ref OBJECT kem_ml_kem_512.c mlkem-native_ml-kem-512_ref/mlkem/src/compress.c mlkem-native_ml-kem-512_ref/mlkem/src/debug.c mlkem-native_ml-kem-512_ref/mlkem/src/indcpa.c mlkem-native_ml-kem-512_ref/mlkem/src/kem.c mlkem-native_ml-kem-512_ref/mlkem/src/poly.c mlkem-native_ml-kem-512_ref/mlkem/src/poly_k.c mlkem-native_ml-kem-512_ref/mlkem/src/sampling.c mlkem-native_ml-kem-512_ref/mlkem/src/verify.c)
    target_compile_options(ml_kem_512_ref PUBLIC -DMLK_CONFIG_PARAMETER_SET=512 -DMLK_CONFIG_FILE="../../integration/liboqs/config_c.h")
    target_include_directories(ml_kem_512_ref PRIVATE ${CMAKE_CURRENT_LIST_DIR}/mlkem-native_ml-kem-512_ref)
    target_include_directories(ml_kem_512_ref PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(ml_kem_512_ref PUBLIC -DMLK_CONFIG_PARAMETER_SET=512 -DMLK_CONFIG_FILE="../../integration/liboqs/config_c.h")
    set(_ML_KEM_OBJS ${_ML_KEM_OBJS} $<TARGET_OBJECTS:ml_kem_512_ref>)
endif()

if(OQS_ENABLE_KEM_ml_kem_512_x86_64)
    add_library(ml_kem_512_x86_64 OBJECT mlkem-native_ml-kem-512_x86_64/mlkem/src/compress.c mlkem-native_ml-kem-512_x86_64/mlkem/src/debug.c mlkem-native_ml-kem-512_x86_64/mlkem/src/indcpa.c mlkem-native_ml-kem-512_x86_64/mlkem/src/kem.c mlkem-native_ml-kem-512_x86_64/mlkem/src/native/x86_64/src/basemul.c mlkem-native_ml-kem-512_x86_64/mlkem/src/native/x86_64/src/basemul.S mlkem-native_ml-kem-512_x86_64/mlkem/src/native/x86_64/src/compress_avx2.c mlkem-native_ml-kem-512_x86_64/mlkem/src/native/x86_64/src/consts.c mlkem-native_ml-kem-512_x86_64/mlkem/src/native/x86_64/src/intt.S mlkem-native_ml-kem-512_x86_64/mlkem/src/native/x86_64/src/mulcache_compute.S mlkem-native_ml-kem-512_x86_64/mlkem/src/native/x86_64/src/ntt.S mlkem-native_ml-kem-512_x86_64/mlkem/src/native/x86_64/src/nttfrombytes.S mlkem-native_ml-kem-512_x86_64/mlkem/src/native/x86_64/src/ntttobytes.S mlkem-native_ml-kem-512_x86_64/mlkem/src/native/x86_64/src/nttunpack.S mlkem-native_ml-kem-512_x86_64/mlkem/src/native/x86_64/src/reduce.S mlkem-native_ml-kem-512_x86_64/mlkem/src/native/x86_64/src/rej_uniform_avx2.c mlkem-native_ml-kem-512_x86_64/mlkem/src/native/x86_64/src/rej_uniform_table.c mlkem-native_ml-kem-512_x86_64/mlkem/src/native/x86_64/src/tomont.S mlkem-native_ml-kem-512_x86_64/mlkem/src/poly.c mlkem-native_ml-kem-512_x86_64/mlkem/src/poly_k.c mlkem-native_ml-kem-512_x86_64/mlkem/src/sampling.c mlkem-native_ml-kem-512_x86_64/mlkem/src/verify.c)
    target_include_directories(ml_kem_512_x86_64 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/mlkem-native_ml-kem-512_x86_64)
    target_include_directories(ml_kem_512_x86_64 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(ml_kem_512_x86_64 PRIVATE  -mavx2  -mbmi2  -mpopcnt )
    target_compile_options(ml_kem_512_x86_64 PUBLIC -DMLK_CONFIG_PARAMETER_SET=512 -DMLK_CONFIG_FILE="../../integration/liboqs/config_x86_64.h")
    set(_ML_KEM_OBJS ${_ML_KEM_OBJS} $<TARGET_OBJECTS:ml_kem_512_x86_64>)
endif()

if(OQS_ENABLE_KEM_ml_kem_512_aarch64)
    add_library(ml_kem_512_aarch64 OBJECT mlkem-native_ml-kem-512_aarch64/mlkem/src/compress.c mlkem-native_ml-kem-512_aarch64/mlkem/src/debug.c mlkem-native_ml-kem-512_aarch64/mlkem/src/indcpa.c mlkem-native_ml-kem-512_aarch64/mlkem/src/kem.c mlkem-native_ml-kem-512_aarch64/mlkem/src/native/aarch64/src/aarch64_zetas.c mlkem-native_ml-kem-512_aarch64/mlkem/src/native/aarch64/src/intt.S mlkem-native_ml-kem-512_aarch64/mlkem/src/native/aarch64/src/ntt.S mlkem-native_ml-kem-512_aarch64/mlkem/src/native/aarch64/src/poly_mulcache_compute_asm.S mlkem-native_ml-kem-512_aarch64/mlkem/src/native/aarch64/src/poly_reduce_asm.S mlkem-native_ml-kem-512_aarch64/mlkem/src/native/aarch64/src/poly_tobytes_asm.S mlkem-native_ml-kem-512_aarch64/mlkem/src/native/aarch64/src/poly_tomont_asm.S mlkem-native_ml-kem-512_aarch64/mlkem/src/native/aarch64/src/polyvec_basemul_acc_montgomery_cached_asm_k2.S mlkem-native_ml-kem-512_aarch64/mlkem/src/native/aarch64/src/polyvec_basemul_acc_montgomery_cached_asm_k3.S mlkem-native_ml-kem-512_aarch64/mlkem/src/native/aarch64/src/polyvec_basemul_acc_montgomery_cached_asm_k4.S mlkem-native_ml-kem-512_aarch64/mlkem/src/native/aarch64/src/rej_uniform_asm.S mlkem-native_ml-kem-512_aarch64/mlkem/src/native/aarch64/src/rej_uniform_table.c mlkem-native_ml-kem-512_aarch64/mlkem/src/poly.c mlkem-native_ml-kem-512_aarch64/mlkem/src/poly_k.c mlkem-native_ml-kem-512_aarch64/mlkem/src/sampling.c mlkem-native_ml-kem-512_aarch64/mlkem/src/verify.c)
    target_include_directories(ml_kem_512_aarch64 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/mlkem-native_ml-kem-512_aarch64)
    target_include_directories(ml_kem_512_aarch64 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(ml_kem_512_aarch64 PUBLIC -DMLK_CONFIG_PARAMETER_SET=512 -DMLK_CONFIG_FILE="../../integration/liboqs/config_aarch64.h")
    set(_ML_KEM_OBJS ${_ML_KEM_OBJS} $<TARGET_OBJECTS:ml_kem_512_aarch64>)
endif()

if(OQS_ENABLE_KEM_ml_kem_512_cuda)
    add_library(ml_kem_512_cuda OBJECT cupqc_ml-kem-512_cuda/cupqc_ml-kem.cu)
    target_link_libraries(ml_kem_512_cuda cupqc)
    set_property(TARGET ml_kem_512_cuda PROPERTY CUDA_ARCHITECTURES OFF)
    target_compile_options(ml_kem_512_cuda PRIVATE $<$<COMPILE_LANGUAGE:CUDA>:-rdc=true -dlto -arch=compute_70>)
    set(_ML_KEM_OBJS ${_ML_KEM_OBJS} $<TARGET_OBJECTS:ml_kem_512_cuda>)
endif()

if(OQS_ENABLE_KEM_ml_kem_512_icicle_cuda)
    add_library(ml_kem_512_icicle_cuda OBJECT icicle_ml-kem-512_icicle_cuda/icicle_ml-kem.cpp)
    target_link_libraries(ml_kem_512_icicle_cuda PRIVATE icicle::icicle_pqc_package)
    set(_ML_KEM_OBJS ${_ML_KEM_OBJS} $<TARGET_OBJECTS:ml_kem_512_icicle_cuda>)
endif()

if(OQS_ENABLE_KEM_ml_kem_768)
    add_library(ml_kem_768_ref OBJECT kem_ml_kem_768.c mlkem-native_ml-kem-768_ref/mlkem/src/compress.c mlkem-native_ml-kem-768_ref/mlkem/src/debug.c mlkem-native_ml-kem-768_ref/mlkem/src/indcpa.c mlkem-native_ml-kem-768_ref/mlkem/src/kem.c mlkem-native_ml-kem-768_ref/mlkem/src/poly.c mlkem-native_ml-kem-768_ref/mlkem/src/poly_k.c mlkem-native_ml-kem-768_ref/mlkem/src/sampling.c mlkem-native_ml-kem-768_ref/mlkem/src/verify.c)
    target_compile_options(ml_kem_768_ref PUBLIC -DMLK_CONFIG_PARAMETER_SET=768 -DMLK_CONFIG_FILE="../../integration/liboqs/config_c.h")
    target_include_directories(ml_kem_768_ref PRIVATE ${CMAKE_CURRENT_LIST_DIR}/mlkem-native_ml-kem-768_ref)
    target_include_directories(ml_kem_768_ref PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(ml_kem_768_ref PUBLIC -DMLK_CONFIG_PARAMETER_SET=768 -DMLK_CONFIG_FILE="../../integration/liboqs/config_c.h")
    set(_ML_KEM_OBJS ${_ML_KEM_OBJS} $<TARGET_OBJECTS:ml_kem_768_ref>)
endif()

if(OQS_ENABLE_KEM_ml_kem_768_x86_64)
    add_library(ml_kem_768_x86_64 OBJECT mlkem-native_ml-kem-768_x86_64/mlkem/src/compress.c mlkem-native_ml-kem-768_x86_64/mlkem/src/debug.c mlkem-native_ml-kem-768_x86_64/mlkem/src/indcpa.c mlkem-native_ml-kem-768_x86_64/mlkem/src/kem.c mlkem-native_ml-kem-768_x86_64/mlkem/src/native/x86_64/src/basemul.c mlkem-native_ml-kem-768_x86_64/mlkem/src/native/x86_64/src/basemul.S mlkem-native_ml-kem-768_x86_64/mlkem/src/native/x86_64/src/compress_avx2.c mlkem-native_ml-kem-768_x86_64/mlkem/src/native/x86_64/src/consts.c mlkem-native_ml-kem-768_x86_64/mlkem/src/native/x86_64/src/intt.S mlkem-native_ml-kem-768_x86_64/mlkem/src/native/x86_64/src/mulcache_compute.S mlkem-native_ml-kem-768_x86_64/mlkem/src/native/x86_64/src/ntt.S mlkem-native_ml-kem-768_x86_64/mlkem/src/native/x86_64/src/nttfrombytes.S mlkem-native_ml-kem-768_x86_64/mlkem/src/native/x86_64/src/ntttobytes.S mlkem-native_ml-kem-768_x86_64/mlkem/src/native/x86_64/src/nttunpack.S mlkem-native_ml-kem-768_x86_64/mlkem/src/native/x86_64/src/reduce.S mlkem-native_ml-kem-768_x86_64/mlkem/src/native/x86_64/src/rej_uniform_avx2.c mlkem-native_ml-kem-768_x86_64/mlkem/src/native/x86_64/src/rej_uniform_table.c mlkem-native_ml-kem-768_x86_64/mlkem/src/native/x86_64/src/tomont.S mlkem-native_ml-kem-768_x86_64/mlkem/src/poly.c mlkem-native_ml-kem-768_x86_64/mlkem/src/poly_k.c mlkem-native_ml-kem-768_x86_64/mlkem/src/sampling.c mlkem-native_ml-kem-768_x86_64/mlkem/src/verify.c)
    target_include_directories(ml_kem_768_x86_64 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/mlkem-native_ml-kem-768_x86_64)
    target_include_directories(ml_kem_768_x86_64 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(ml_kem_768_x86_64 PRIVATE  -mavx2  -mbmi2  -mpopcnt )
    target_compile_options(ml_kem_768_x86_64 PUBLIC -DMLK_CONFIG_PARAMETER_SET=768 -DMLK_CONFIG_FILE="../../integration/liboqs/config_x86_64.h")
    set(_ML_KEM_OBJS ${_ML_KEM_OBJS} $<TARGET_OBJECTS:ml_kem_768_x86_64>)
endif()

if(OQS_ENABLE_KEM_ml_kem_768_aarch64)
    add_library(ml_kem_768_aarch64 OBJECT mlkem-native_ml-kem-768_aarch64/mlkem/src/compress.c mlkem-native_ml-kem-768_aarch64/mlkem/src/debug.c mlkem-native_ml-kem-768_aarch64/mlkem/src/indcpa.c mlkem-native_ml-kem-768_aarch64/mlkem/src/kem.c mlkem-native_ml-kem-768_aarch64/mlkem/src/native/aarch64/src/aarch64_zetas.c mlkem-native_ml-kem-768_aarch64/mlkem/src/native/aarch64/src/intt.S mlkem-native_ml-kem-768_aarch64/mlkem/src/native/aarch64/src/ntt.S mlkem-native_ml-kem-768_aarch64/mlkem/src/native/aarch64/src/poly_mulcache_compute_asm.S mlkem-native_ml-kem-768_aarch64/mlkem/src/native/aarch64/src/poly_reduce_asm.S mlkem-native_ml-kem-768_aarch64/mlkem/src/native/aarch64/src/poly_tobytes_asm.S mlkem-native_ml-kem-768_aarch64/mlkem/src/native/aarch64/src/poly_tomont_asm.S mlkem-native_ml-kem-768_aarch64/mlkem/src/native/aarch64/src/polyvec_basemul_acc_montgomery_cached_asm_k2.S mlkem-native_ml-kem-768_aarch64/mlkem/src/native/aarch64/src/polyvec_basemul_acc_montgomery_cached_asm_k3.S mlkem-native_ml-kem-768_aarch64/mlkem/src/native/aarch64/src/polyvec_basemul_acc_montgomery_cached_asm_k4.S mlkem-native_ml-kem-768_aarch64/mlkem/src/native/aarch64/src/rej_uniform_asm.S mlkem-native_ml-kem-768_aarch64/mlkem/src/native/aarch64/src/rej_uniform_table.c mlkem-native_ml-kem-768_aarch64/mlkem/src/poly.c mlkem-native_ml-kem-768_aarch64/mlkem/src/poly_k.c mlkem-native_ml-kem-768_aarch64/mlkem/src/sampling.c mlkem-native_ml-kem-768_aarch64/mlkem/src/verify.c)
    target_include_directories(ml_kem_768_aarch64 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/mlkem-native_ml-kem-768_aarch64)
    target_include_directories(ml_kem_768_aarch64 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(ml_kem_768_aarch64 PUBLIC -DMLK_CONFIG_PARAMETER_SET=768 -DMLK_CONFIG_FILE="../../integration/liboqs/config_aarch64.h")
    set(_ML_KEM_OBJS ${_ML_KEM_OBJS} $<TARGET_OBJECTS:ml_kem_768_aarch64>)
endif()

if(OQS_ENABLE_KEM_ml_kem_768_cuda)
    add_library(ml_kem_768_cuda OBJECT cupqc_ml-kem-768_cuda/cupqc_ml-kem.cu)
    target_link_libraries(ml_kem_768_cuda cupqc)
    set_property(TARGET ml_kem_768_cuda PROPERTY CUDA_ARCHITECTURES OFF)
    target_compile_options(ml_kem_768_cuda PRIVATE $<$<COMPILE_LANGUAGE:CUDA>:-rdc=true -dlto -arch=compute_70>)
    set(_ML_KEM_OBJS ${_ML_KEM_OBJS} $<TARGET_OBJECTS:ml_kem_768_cuda>)
endif()

if(OQS_ENABLE_KEM_ml_kem_768_icicle_cuda)
    add_library(ml_kem_768_icicle_cuda OBJECT icicle_ml-kem-768_icicle_cuda/icicle_ml-kem.cpp)
    target_link_libraries(ml_kem_768_icicle_cuda PRIVATE icicle::icicle_pqc_package)
    set(_ML_KEM_OBJS ${_ML_KEM_OBJS} $<TARGET_OBJECTS:ml_kem_768_icicle_cuda>)
endif()

if(OQS_ENABLE_KEM_ml_kem_1024)

=== src/kem/ntru/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

# This file was generated by
# scripts/copy_from_upstream/copy_from_upstream.py

set(_NTRU_OBJS "")

if(OQS_ENABLE_KEM_ntru_hps2048509)
    add_library(ntru_hps2048509_clean OBJECT kem_ntru_hps2048509.c pqclean_ntruhps2048509_clean/cmov.c pqclean_ntruhps2048509_clean/crypto_sort_int32.c pqclean_ntruhps2048509_clean/kem.c pqclean_ntruhps2048509_clean/owcpa.c pqclean_ntruhps2048509_clean/pack3.c pqclean_ntruhps2048509_clean/packq.c pqclean_ntruhps2048509_clean/poly.c pqclean_ntruhps2048509_clean/poly_lift.c pqclean_ntruhps2048509_clean/poly_mod.c pqclean_ntruhps2048509_clean/poly_r2_inv.c pqclean_ntruhps2048509_clean/poly_rq_mul.c pqclean_ntruhps2048509_clean/poly_s3_inv.c pqclean_ntruhps2048509_clean/sample.c pqclean_ntruhps2048509_clean/sample_iid.c)
    target_include_directories(ntru_hps2048509_clean PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_ntruhps2048509_clean)
    target_include_directories(ntru_hps2048509_clean PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    if (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
        target_compile_definitions(ntru_hps2048509_clean PRIVATE old_gas_syntax)
    endif()
    set(_NTRU_OBJS ${_NTRU_OBJS} $<TARGET_OBJECTS:ntru_hps2048509_clean>)
endif()

if(OQS_ENABLE_KEM_ntru_hps2048509_avx2)
    add_library(ntru_hps2048509_avx2 OBJECT pqclean_ntruhps2048509_avx2/cmov.c pqclean_ntruhps2048509_avx2/crypto_sort_int32.c pqclean_ntruhps2048509_avx2/kem.c pqclean_ntruhps2048509_avx2/owcpa.c pqclean_ntruhps2048509_avx2/pack3.c pqclean_ntruhps2048509_avx2/packq.c pqclean_ntruhps2048509_avx2/poly.c pqclean_ntruhps2048509_avx2/poly_lift.c pqclean_ntruhps2048509_avx2/poly_mod_3_Phi_n.s pqclean_ntruhps2048509_avx2/poly_mod_q_Phi_n.s pqclean_ntruhps2048509_avx2/poly_r2_inv.c pqclean_ntruhps2048509_avx2/poly_r2_mul.s pqclean_ntruhps2048509_avx2/poly_rq_mul.s pqclean_ntruhps2048509_avx2/poly_rq_to_s3.s pqclean_ntruhps2048509_avx2/poly_s3_inv.c pqclean_ntruhps2048509_avx2/sample.c pqclean_ntruhps2048509_avx2/sample_iid.c pqclean_ntruhps2048509_avx2/square_126_509_shufbytes.s pqclean_ntruhps2048509_avx2/square_15_509_shufbytes.s pqclean_ntruhps2048509_avx2/square_1_509_patience.s pqclean_ntruhps2048509_avx2/square_252_509_shufbytes.s pqclean_ntruhps2048509_avx2/square_30_509_shufbytes.s pqclean_ntruhps2048509_avx2/square_3_509_patience.s pqclean_ntruhps2048509_avx2/square_63_509_shufbytes.s pqclean_ntruhps2048509_avx2/square_6_509_patience.s pqclean_ntruhps2048509_avx2/vec32_sample_iid.s)
    target_include_directories(ntru_hps2048509_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_ntruhps2048509_avx2)
    target_include_directories(ntru_hps2048509_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(ntru_hps2048509_avx2 PRIVATE  -mavx2  -mbmi2 )
    if (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
        target_compile_definitions(ntru_hps2048509_avx2 PRIVATE old_gas_syntax)
    endif()
    set(_NTRU_OBJS ${_NTRU_OBJS} $<TARGET_OBJECTS:ntru_hps2048509_avx2>)
endif()

if(OQS_ENABLE_KEM_ntru_hps2048677)
    add_library(ntru_hps2048677_clean OBJECT kem_ntru_hps2048677.c pqclean_ntruhps2048677_clean/cmov.c pqclean_ntruhps2048677_clean/crypto_sort_int32.c pqclean_ntruhps2048677_clean/kem.c pqclean_ntruhps2048677_clean/owcpa.c pqclean_ntruhps2048677_clean/pack3.c pqclean_ntruhps2048677_clean/packq.c pqclean_ntruhps2048677_clean/poly.c pqclean_ntruhps2048677_clean/poly_lift.c pqclean_ntruhps2048677_clean/poly_mod.c pqclean_ntruhps2048677_clean/poly_r2_inv.c pqclean_ntruhps2048677_clean/poly_rq_mul.c pqclean_ntruhps2048677_clean/poly_s3_inv.c pqclean_ntruhps2048677_clean/sample.c pqclean_ntruhps2048677_clean/sample_iid.c)
    target_include_directories(ntru_hps2048677_clean PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_ntruhps2048677_clean)
    target_include_directories(ntru_hps2048677_clean PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    if (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
        target_compile_definitions(ntru_hps2048677_clean PRIVATE old_gas_syntax)
    endif()
    set(_NTRU_OBJS ${_NTRU_OBJS} $<TARGET_OBJECTS:ntru_hps2048677_clean>)
endif()

if(OQS_ENABLE_KEM_ntru_hps2048677_avx2)
    add_library(ntru_hps2048677_avx2 OBJECT pqclean_ntruhps2048677_avx2/cmov.c pqclean_ntruhps2048677_avx2/crypto_sort_int32.c pqclean_ntruhps2048677_avx2/kem.c pqclean_ntruhps2048677_avx2/owcpa.c pqclean_ntruhps2048677_avx2/pack3.c pqclean_ntruhps2048677_avx2/packq.c pqclean_ntruhps2048677_avx2/poly.c pqclean_ntruhps2048677_avx2/poly_lift.c pqclean_ntruhps2048677_avx2/poly_mod_3_Phi_n.s pqclean_ntruhps2048677_avx2/poly_mod_q_Phi_n.s pqclean_ntruhps2048677_avx2/poly_r2_inv.c pqclean_ntruhps2048677_avx2/poly_r2_mul.s pqclean_ntruhps2048677_avx2/poly_rq_mul.s pqclean_ntruhps2048677_avx2/poly_rq_to_s3.s pqclean_ntruhps2048677_avx2/poly_s3_inv.c pqclean_ntruhps2048677_avx2/sample.c pqclean_ntruhps2048677_avx2/sample_iid.c pqclean_ntruhps2048677_avx2/square_10_677_shufbytes.s pqclean_ntruhps2048677_avx2/square_168_677_shufbytes.s pqclean_ntruhps2048677_avx2/square_1_677_patience.s pqclean_ntruhps2048677_avx2/square_21_677_shufbytes.s pqclean_ntruhps2048677_avx2/square_2_677_patience.s pqclean_ntruhps2048677_avx2/square_336_677_shufbytes.s pqclean_ntruhps2048677_avx2/square_3_677_patience.s pqclean_ntruhps2048677_avx2/square_42_677_shufbytes.s pqclean_ntruhps2048677_avx2/square_5_677_patience.s pqclean_ntruhps2048677_avx2/square_84_677_shufbytes.s pqclean_ntruhps2048677_avx2/vec32_sample_iid.s)
    target_include_directories(ntru_hps2048677_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_ntruhps2048677_avx2)
    target_include_directories(ntru_hps2048677_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(ntru_hps2048677_avx2 PRIVATE  -mavx2  -mbmi2 )
    if (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
        target_compile_definitions(ntru_hps2048677_avx2 PRIVATE old_gas_syntax)
    endif()
    set(_NTRU_OBJS ${_NTRU_OBJS} $<TARGET_OBJECTS:ntru_hps2048677_avx2>)
endif()

if(OQS_ENABLE_KEM_ntru_hps4096821)
    add_library(ntru_hps4096821_clean OBJECT kem_ntru_hps4096821.c pqclean_ntruhps4096821_clean/cmov.c pqclean_ntruhps4096821_clean/crypto_sort_int32.c pqclean_ntruhps4096821_clean/kem.c pqclean_ntruhps4096821_clean/owcpa.c pqclean_ntruhps4096821_clean/pack3.c pqclean_ntruhps4096821_clean/packq.c pqclean_ntruhps4096821_clean/poly.c pqclean_ntruhps4096821_clean/poly_lift.c pqclean_ntruhps4096821_clean/poly_mod.c pqclean_ntruhps4096821_clean/poly_r2_inv.c pqclean_ntruhps4096821_clean/poly_rq_mul.c pqclean_ntruhps4096821_clean/poly_s3_inv.c pqclean_ntruhps4096821_clean/sample.c pqclean_ntruhps4096821_clean/sample_iid.c)
    target_include_directories(ntru_hps4096821_clean PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_ntruhps4096821_clean)
    target_include_directories(ntru_hps4096821_clean PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    if (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
        target_compile_definitions(ntru_hps4096821_clean PRIVATE old_gas_syntax)
    endif()
    set(_NTRU_OBJS ${_NTRU_OBJS} $<TARGET_OBJECTS:ntru_hps4096821_clean>)
endif()

if(OQS_ENABLE_KEM_ntru_hps4096821_avx2)
    add_library(ntru_hps4096821_avx2 OBJECT pqclean_ntruhps4096821_avx2/cmov.c pqclean_ntruhps4096821_avx2/crypto_sort_int32.c pqclean_ntruhps4096821_avx2/kem.c pqclean_ntruhps4096821_avx2/owcpa.c pqclean_ntruhps4096821_avx2/pack3.c pqclean_ntruhps4096821_avx2/packq.c pqclean_ntruhps4096821_avx2/poly.c pqclean_ntruhps4096821_avx2/poly_lift.c pqclean_ntruhps4096821_avx2/poly_mod_3_Phi_n.s pqclean_ntruhps4096821_avx2/poly_mod_q_Phi_n.s pqclean_ntruhps4096821_avx2/poly_r2_inv.c pqclean_ntruhps4096821_avx2/poly_r2_mul.s pqclean_ntruhps4096821_avx2/poly_rq_mul.s pqclean_ntruhps4096821_avx2/poly_rq_to_s3.s pqclean_ntruhps4096821_avx2/poly_s3_inv.c pqclean_ntruhps4096821_avx2/sample.c pqclean_ntruhps4096821_avx2/sample_iid.c pqclean_ntruhps4096821_avx2/square_102_821_shufbytes.s pqclean_ntruhps4096821_avx2/square_12_821_shufbytes.s pqclean_ntruhps4096821_avx2/square_1_821_patience.s pqclean_ntruhps4096821_avx2/square_204_821_shufbytes.s pqclean_ntruhps4096821_avx2/square_24_821_shufbytes.s pqclean_ntruhps4096821_avx2/square_3_821_patience.s pqclean_ntruhps4096821_avx2/square_408_821_shufbytes.s pqclean_ntruhps4096821_avx2/square_51_821_shufbytes.s pqclean_ntruhps4096821_avx2/square_6_821_patience.s pqclean_ntruhps4096821_avx2/vec32_sample_iid.s)
    target_include_directories(ntru_hps4096821_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_ntruhps4096821_avx2)
    target_include_directories(ntru_hps4096821_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(ntru_hps4096821_avx2 PRIVATE  -mavx2  -mbmi2 )
    if (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
        target_compile_definitions(ntru_hps4096821_avx2 PRIVATE old_gas_syntax)
    endif()
    set(_NTRU_OBJS ${_NTRU_OBJS} $<TARGET_OBJECTS:ntru_hps4096821_avx2>)
endif()

if(OQS_ENABLE_KEM_ntru_hps40961229)
    add_library(ntru_hps40961229_clean OBJECT kem_ntru_hps40961229.c pqclean_ntruhps40961229_clean/cmov.c pqclean_ntruhps40961229_clean/crypto_sort_int32.c pqclean_ntruhps40961229_clean/kem.c pqclean_ntruhps40961229_clean/owcpa.c pqclean_ntruhps40961229_clean/pack3.c pqclean_ntruhps40961229_clean/packq.c pqclean_ntruhps40961229_clean/poly.c pqclean_ntruhps40961229_clean/poly_lift.c pqclean_ntruhps40961229_clean/poly_mod.c pqclean_ntruhps40961229_clean/poly_r2_inv.c pqclean_ntruhps40961229_clean/poly_rq_mul.c pqclean_ntruhps40961229_clean/poly_s3_inv.c pqclean_ntruhps40961229_clean/sample.c pqclean_ntruhps40961229_clean/sample_iid.c)
    target_include_directories(ntru_hps40961229_clean PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_ntruhps40961229_clean)
    target_include_directories(ntru_hps40961229_clean PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    if (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
        target_compile_definitions(ntru_hps40961229_clean PRIVATE old_gas_syntax)
    endif()
    set(_NTRU_OBJS ${_NTRU_OBJS} $<TARGET_OBJECTS:ntru_hps40961229_clean>)
endif()

if(OQS_ENABLE_KEM_ntru_hrss701)
    add_library(ntru_hrss701_clean OBJECT kem_ntru_hrss701.c pqclean_ntruhrss701_clean/cmov.c pqclean_ntruhrss701_clean/kem.c pqclean_ntruhrss701_clean/owcpa.c pqclean_ntruhrss701_clean/pack3.c pqclean_ntruhrss701_clean/packq.c pqclean_ntruhrss701_clean/poly.c pqclean_ntruhrss701_clean/poly_lift.c pqclean_ntruhrss701_clean/poly_mod.c pqclean_ntruhrss701_clean/poly_r2_inv.c pqclean_ntruhrss701_clean/poly_rq_mul.c pqclean_ntruhrss701_clean/poly_s3_inv.c pqclean_ntruhrss701_clean/sample.c pqclean_ntruhrss701_clean/sample_iid.c)
    target_include_directories(ntru_hrss701_clean PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_ntruhrss701_clean)
    target_include_directories(ntru_hrss701_clean PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    if (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
        target_compile_definitions(ntru_hrss701_clean PRIVATE old_gas_syntax)
    endif()
    set(_NTRU_OBJS ${_NTRU_OBJS} $<TARGET_OBJECTS:ntru_hrss701_clean>)
endif()

if(OQS_ENABLE_KEM_ntru_hrss701_avx2)

=== src/sig/slh_dsa/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

set(_SLH_DSA_OBJS "")

if (OQS_ENABLE_SIG_SLH_DSA)
	add_library(slh_dsa_c OBJECT
	            slh_dsa_c/sha2_256.c
	            slh_dsa_c/sha2_512.c
	            slh_dsa_c/sha3_api.c
	            slh_dsa_c/sha3_f1600.c
	            slh_dsa_c/slh_dsa.c
	            slh_dsa_c/slh_prehash.c
	            slh_dsa_c/slh_sha2.c
	            slh_dsa_c/slh_shake.c
	            wrappers/prehash_sha2_224/slh_dsa_sha2_224_prehash_sha2_128f.c
	            wrappers/prehash_sha2_224/slh_dsa_sha2_224_prehash_sha2_128s.c
	            wrappers/prehash_sha2_224/slh_dsa_sha2_224_prehash_sha2_192f.c
	            wrappers/prehash_sha2_224/slh_dsa_sha2_224_prehash_sha2_192s.c
	            wrappers/prehash_sha2_224/slh_dsa_sha2_224_prehash_sha2_256f.c
	            wrappers/prehash_sha2_224/slh_dsa_sha2_224_prehash_sha2_256s.c
	            wrappers/prehash_sha2_224/slh_dsa_sha2_224_prehash_shake_128f.c
	            wrappers/prehash_sha2_224/slh_dsa_sha2_224_prehash_shake_128s.c
	            wrappers/prehash_sha2_224/slh_dsa_sha2_224_prehash_shake_192f.c
	            wrappers/prehash_sha2_224/slh_dsa_sha2_224_prehash_shake_192s.c
	            wrappers/prehash_sha2_224/slh_dsa_sha2_224_prehash_shake_256f.c
	            wrappers/prehash_sha2_224/slh_dsa_sha2_224_prehash_shake_256s.c
	            wrappers/prehash_sha2_256/slh_dsa_sha2_256_prehash_sha2_128f.c
	            wrappers/prehash_sha2_256/slh_dsa_sha2_256_prehash_sha2_128s.c
	            wrappers/prehash_sha2_256/slh_dsa_sha2_256_prehash_sha2_192f.c
	            wrappers/prehash_sha2_256/slh_dsa_sha2_256_prehash_sha2_192s.c
	            wrappers/prehash_sha2_256/slh_dsa_sha2_256_prehash_sha2_256f.c
	            wrappers/prehash_sha2_256/slh_dsa_sha2_256_prehash_sha2_256s.c
	            wrappers/prehash_sha2_256/slh_dsa_sha2_256_prehash_shake_128f.c
	            wrappers/prehash_sha2_256/slh_dsa_sha2_256_prehash_shake_128s.c
	            wrappers/prehash_sha2_256/slh_dsa_sha2_256_prehash_shake_192f.c
	            wrappers/prehash_sha2_256/slh_dsa_sha2_256_prehash_shake_192s.c
	            wrappers/prehash_sha2_256/slh_dsa_sha2_256_prehash_shake_256f.c
	            wrappers/prehash_sha2_256/slh_dsa_sha2_256_prehash_shake_256s.c
	            wrappers/prehash_sha2_384/slh_dsa_sha2_384_prehash_sha2_128f.c
	            wrappers/prehash_sha2_384/slh_dsa_sha2_384_prehash_sha2_128s.c
	            wrappers/prehash_sha2_384/slh_dsa_sha2_384_prehash_sha2_192f.c
	            wrappers/prehash_sha2_384/slh_dsa_sha2_384_prehash_sha2_192s.c
	            wrappers/prehash_sha2_384/slh_dsa_sha2_384_prehash_sha2_256f.c
	            wrappers/prehash_sha2_384/slh_dsa_sha2_384_prehash_sha2_256s.c
	            wrappers/prehash_sha2_384/slh_dsa_sha2_384_prehash_shake_128f.c
	            wrappers/prehash_sha2_384/slh_dsa_sha2_384_prehash_shake_128s.c
	            wrappers/prehash_sha2_384/slh_dsa_sha2_384_prehash_shake_192f.c
	            wrappers/prehash_sha2_384/slh_dsa_sha2_384_prehash_shake_192s.c
	            wrappers/prehash_sha2_384/slh_dsa_sha2_384_prehash_shake_256f.c
	            wrappers/prehash_sha2_384/slh_dsa_sha2_384_prehash_shake_256s.c
	            wrappers/prehash_sha2_512/slh_dsa_sha2_512_prehash_sha2_128f.c
	            wrappers/prehash_sha2_512/slh_dsa_sha2_512_prehash_sha2_128s.c
	            wrappers/prehash_sha2_512/slh_dsa_sha2_512_prehash_sha2_192f.c
	            wrappers/prehash_sha2_512/slh_dsa_sha2_512_prehash_sha2_192s.c
	            wrappers/prehash_sha2_512/slh_dsa_sha2_512_prehash_sha2_256f.c
	            wrappers/prehash_sha2_512/slh_dsa_sha2_512_prehash_sha2_256s.c
	            wrappers/prehash_sha2_512/slh_dsa_sha2_512_prehash_shake_128f.c
	            wrappers/prehash_sha2_512/slh_dsa_sha2_512_prehash_shake_128s.c
	            wrappers/prehash_sha2_512/slh_dsa_sha2_512_prehash_shake_192f.c
	            wrappers/prehash_sha2_512/slh_dsa_sha2_512_prehash_shake_192s.c
	            wrappers/prehash_sha2_512/slh_dsa_sha2_512_prehash_shake_256f.c
	            wrappers/prehash_sha2_512/slh_dsa_sha2_512_prehash_shake_256s.c
	            wrappers/prehash_sha2_512_224/slh_dsa_sha2_512_224_prehash_sha2_128f.c
	            wrappers/prehash_sha2_512_224/slh_dsa_sha2_512_224_prehash_sha2_128s.c
	            wrappers/prehash_sha2_512_224/slh_dsa_sha2_512_224_prehash_sha2_192f.c
	            wrappers/prehash_sha2_512_224/slh_dsa_sha2_512_224_prehash_sha2_192s.c
	            wrappers/prehash_sha2_512_224/slh_dsa_sha2_512_224_prehash_sha2_256f.c
	            wrappers/prehash_sha2_512_224/slh_dsa_sha2_512_224_prehash_sha2_256s.c
	            wrappers/prehash_sha2_512_224/slh_dsa_sha2_512_224_prehash_shake_128f.c
	            wrappers/prehash_sha2_512_224/slh_dsa_sha2_512_224_prehash_shake_128s.c
	            wrappers/prehash_sha2_512_224/slh_dsa_sha2_512_224_prehash_shake_192f.c
	            wrappers/prehash_sha2_512_224/slh_dsa_sha2_512_224_prehash_shake_192s.c
	            wrappers/prehash_sha2_512_224/slh_dsa_sha2_512_224_prehash_shake_256f.c
	            wrappers/prehash_sha2_512_224/slh_dsa_sha2_512_224_prehash_shake_256s.c
	            wrappers/prehash_sha2_512_256/slh_dsa_sha2_512_256_prehash_sha2_128f.c
	            wrappers/prehash_sha2_512_256/slh_dsa_sha2_512_256_prehash_sha2_128s.c
	            wrappers/prehash_sha2_512_256/slh_dsa_sha2_512_256_prehash_sha2_192f.c
	            wrappers/prehash_sha2_512_256/slh_dsa_sha2_512_256_prehash_sha2_192s.c
	            wrappers/prehash_sha2_512_256/slh_dsa_sha2_512_256_prehash_sha2_256f.c
	            wrappers/prehash_sha2_512_256/slh_dsa_sha2_512_256_prehash_sha2_256s.c
	            wrappers/prehash_sha2_512_256/slh_dsa_sha2_512_256_prehash_shake_128f.c
	            wrappers/prehash_sha2_512_256/slh_dsa_sha2_512_256_prehash_shake_128s.c
	            wrappers/prehash_sha2_512_256/slh_dsa_sha2_512_256_prehash_shake_192f.c
	            wrappers/prehash_sha2_512_256/slh_dsa_sha2_512_256_prehash_shake_192s.c
	            wrappers/prehash_sha2_512_256/slh_dsa_sha2_512_256_prehash_shake_256f.c
	            wrappers/prehash_sha2_512_256/slh_dsa_sha2_512_256_prehash_shake_256s.c
	            wrappers/prehash_sha3_224/slh_dsa_sha3_224_prehash_sha2_128f.c
	            wrappers/prehash_sha3_224/slh_dsa_sha3_224_prehash_sha2_128s.c
	            wrappers/prehash_sha3_224/slh_dsa_sha3_224_prehash_sha2_192f.c
	            wrappers/prehash_sha3_224/slh_dsa_sha3_224_prehash_sha2_192s.c
	            wrappers/prehash_sha3_224/slh_dsa_sha3_224_prehash_sha2_256f.c
	            wrappers/prehash_sha3_224/slh_dsa_sha3_224_prehash_sha2_256s.c
	            wrappers/prehash_sha3_224/slh_dsa_sha3_224_prehash_shake_128f.c
	            wrappers/prehash_sha3_224/slh_dsa_sha3_224_prehash_shake_128s.c
	            wrappers/prehash_sha3_224/slh_dsa_sha3_224_prehash_shake_192f.c
	            wrappers/prehash_sha3_224/slh_dsa_sha3_224_prehash_shake_192s.c
	            wrappers/prehash_sha3_224/slh_dsa_sha3_224_prehash_shake_256f.c
	            wrappers/prehash_sha3_224/slh_dsa_sha3_224_prehash_shake_256s.c
	            wrappers/prehash_sha3_256/slh_dsa_sha3_256_prehash_sha2_128f.c
	            wrappers/prehash_sha3_256/slh_dsa_sha3_256_prehash_sha2_128s.c
	            wrappers/prehash_sha3_256/slh_dsa_sha3_256_prehash_sha2_192f.c
	            wrappers/prehash_sha3_256/slh_dsa_sha3_256_prehash_sha2_192s.c
	            wrappers/prehash_sha3_256/slh_dsa_sha3_256_prehash_sha2_256f.c
	            wrappers/prehash_sha3_256/slh_dsa_sha3_256_prehash_sha2_256s.c
	            wrappers/prehash_sha3_256/slh_dsa_sha3_256_prehash_shake_128f.c
	            wrappers/prehash_sha3_256/slh_dsa_sha3_256_prehash_shake_128s.c
	            wrappers/prehash_sha3_256/slh_dsa_sha3_256_prehash_shake_192f.c
	            wrappers/prehash_sha3_256/slh_dsa_sha3_256_prehash_shake_192s.c
	            wrappers/prehash_sha3_256/slh_dsa_sha3_256_prehash_shake_256f.c
	            wrappers/prehash_sha3_256/slh_dsa_sha3_256_prehash_shake_256s.c
	            wrappers/prehash_sha3_384/slh_dsa_sha3_384_prehash_sha2_128f.c
	            wrappers/prehash_sha3_384/slh_dsa_sha3_384_prehash_sha2_128s.c
	            wrappers/prehash_sha3_384/slh_dsa_sha3_384_prehash_sha2_192f.c
	            wrappers/prehash_sha3_384/slh_dsa_sha3_384_prehash_sha2_192s.c
	            wrappers/prehash_sha3_384/slh_dsa_sha3_384_prehash_sha2_256f.c
	            wrappers/prehash_sha3_384/slh_dsa_sha3_384_prehash_sha2_256s.c
	            wrappers/prehash_sha3_384/slh_dsa_sha3_384_prehash_shake_128f.c
	            wrappers/prehash_sha3_384/slh_dsa_sha3_384_prehash_shake_128s.c
	            wrappers/prehash_sha3_384/slh_dsa_sha3_384_prehash_shake_192f.c
	            wrappers/prehash_sha3_384/slh_dsa_sha3_384_prehash_shake_192s.c
	            wrappers/prehash_sha3_384/slh_dsa_sha3_384_prehash_shake_256f.c
	            wrappers/prehash_sha3_384/slh_dsa_sha3_384_prehash_shake_256s.c
	            wrappers/prehash_sha3_512/slh_dsa_sha3_512_prehash_sha2_128f.c
	            wrappers/prehash_sha3_512/slh_dsa_sha3_512_prehash_sha2_128s.c
	            wrappers/prehash_sha3_512/slh_dsa_sha3_512_prehash_sha2_192f.c
	            wrappers/prehash_sha3_512/slh_dsa_sha3_512_prehash_sha2_192s.c
	            wrappers/prehash_sha3_512/slh_dsa_sha3_512_prehash_sha2_256f.c
	            wrappers/prehash_sha3_512/slh_dsa_sha3_512_prehash_sha2_256s.c
	            wrappers/prehash_sha3_512/slh_dsa_sha3_512_prehash_shake_128f.c
	            wrappers/prehash_sha3_512/slh_dsa_sha3_512_prehash_shake_128s.c
	            wrappers/prehash_sha3_512/slh_dsa_sha3_512_prehash_shake_192f.c
	            wrappers/prehash_sha3_512/slh_dsa_sha3_512_prehash_shake_192s.c
	            wrappers/prehash_sha3_512/slh_dsa_sha3_512_prehash_shake_256f.c
	            wrappers/prehash_sha3_512/slh_dsa_sha3_512_prehash_shake_256s.c
	            wrappers/prehash_shake_128/slh_dsa_shake_128_prehash_sha2_128f.c
	            wrappers/prehash_shake_128/slh_dsa_shake_128_prehash_sha2_128s.c
	            wrappers/prehash_shake_128/slh_dsa_shake_128_prehash_sha2_192f.c
	            wrappers/prehash_shake_128/slh_dsa_shake_128_prehash_sha2_192s.c
	            wrappers/prehash_shake_128/slh_dsa_shake_128_prehash_sha2_256f.c
	            wrappers/prehash_shake_128/slh_dsa_shake_128_prehash_sha2_256s.c
	            wrappers/prehash_shake_128/slh_dsa_shake_128_prehash_shake_128f.c
	            wrappers/prehash_shake_128/slh_dsa_shake_128_prehash_shake_128s.c
	            wrappers/prehash_shake_128/slh_dsa_shake_128_prehash_shake_192f.c
	            wrappers/prehash_shake_128/slh_dsa_shake_128_prehash_shake_192s.c
	            wrappers/prehash_shake_128/slh_dsa_shake_128_prehash_shake_256f.c
	            wrappers/prehash_shake_128/slh_dsa_shake_128_prehash_shake_256s.c
	            wrappers/prehash_shake_256/slh_dsa_shake_256_prehash_sha2_128f.c
	            wrappers/prehash_shake_256/slh_dsa_shake_256_prehash_sha2_128s.c
	            wrappers/prehash_shake_256/slh_dsa_shake_256_prehash_sha2_192f.c
	            wrappers/prehash_shake_256/slh_dsa_shake_256_prehash_sha2_192s.c
	            wrappers/prehash_shake_256/slh_dsa_shake_256_prehash_sha2_256f.c
	            wrappers/prehash_shake_256/slh_dsa_shake_256_prehash_sha2_256s.c
	            wrappers/prehash_shake_256/slh_dsa_shake_256_prehash_shake_128f.c
	            wrappers/prehash_shake_256/slh_dsa_shake_256_prehash_shake_128s.c
	            wrappers/prehash_shake_256/slh_dsa_shake_256_prehash_shake_192f.c
	            wrappers/prehash_shake_256/slh_dsa_shake_256_prehash_shake_192s.c
	            wrappers/prehash_shake_256/slh_dsa_shake_256_prehash_shake_256f.c
	            wrappers/prehash_shake_256/slh_dsa_shake_256_prehash_shake_256s.c
	            wrappers/pure/slh_dsa_pure_sha2_128f.c
	            wrappers/pure/slh_dsa_pure_sha2_128s.c
	            wrappers/pure/slh_dsa_pure_sha2_192f.c
	            wrappers/pure/slh_dsa_pure_sha2_192s.c
	            wrappers/pure/slh_dsa_pure_sha2_256f.c
	            wrappers/pure/slh_dsa_pure_sha2_256s.c

=== src/sig/sphincs/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

# This file was generated by
# scripts/copy_from_upstream/copy_from_upstream.py

set(_SPHINCS_OBJS "")

if(OQS_ENABLE_SIG_sphincs_sha2_128f_simple)
    add_library(sphincs_sha2_128f_simple_clean OBJECT sig_sphincs_sha2_128f_simple.c pqclean_sphincs-sha2-128f-simple_clean/address.c pqclean_sphincs-sha2-128f-simple_clean/context_sha2.c pqclean_sphincs-sha2-128f-simple_clean/fors.c pqclean_sphincs-sha2-128f-simple_clean/hash_sha2.c pqclean_sphincs-sha2-128f-simple_clean/merkle.c pqclean_sphincs-sha2-128f-simple_clean/sign.c pqclean_sphincs-sha2-128f-simple_clean/thash_sha2_simple.c pqclean_sphincs-sha2-128f-simple_clean/utils.c pqclean_sphincs-sha2-128f-simple_clean/utilsx1.c pqclean_sphincs-sha2-128f-simple_clean/wots.c pqclean_sphincs-sha2-128f-simple_clean/wotsx1.c)
    target_include_directories(sphincs_sha2_128f_simple_clean PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-128f-simple_clean)
    target_include_directories(sphincs_sha2_128f_simple_clean PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_128f_simple_clean>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_128f_simple_avx2)
    add_library(sphincs_sha2_128f_simple_avx2 OBJECT pqclean_sphincs-sha2-128f-simple_avx2/address.c pqclean_sphincs-sha2-128f-simple_avx2/context_sha2.c pqclean_sphincs-sha2-128f-simple_avx2/fors.c pqclean_sphincs-sha2-128f-simple_avx2/hash_sha2.c pqclean_sphincs-sha2-128f-simple_avx2/hash_sha2x8.c pqclean_sphincs-sha2-128f-simple_avx2/merkle.c pqclean_sphincs-sha2-128f-simple_avx2/sha256avx.c pqclean_sphincs-sha2-128f-simple_avx2/sha256x8.c pqclean_sphincs-sha2-128f-simple_avx2/sign.c pqclean_sphincs-sha2-128f-simple_avx2/thash_sha2_simple.c pqclean_sphincs-sha2-128f-simple_avx2/thash_sha2_simplex8.c pqclean_sphincs-sha2-128f-simple_avx2/utils.c pqclean_sphincs-sha2-128f-simple_avx2/utilsx8.c pqclean_sphincs-sha2-128f-simple_avx2/wots.c)
    target_include_directories(sphincs_sha2_128f_simple_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-128f-simple_avx2)
    target_include_directories(sphincs_sha2_128f_simple_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(sphincs_sha2_128f_simple_avx2 PRIVATE -mavx2)
    target_compile_options(sphincs_sha2_128f_simple_avx2 PUBLIC -fno-strict-aliasing)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_128f_simple_avx2>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_128s_simple)
    add_library(sphincs_sha2_128s_simple_clean OBJECT sig_sphincs_sha2_128s_simple.c pqclean_sphincs-sha2-128s-simple_clean/address.c pqclean_sphincs-sha2-128s-simple_clean/context_sha2.c pqclean_sphincs-sha2-128s-simple_clean/fors.c pqclean_sphincs-sha2-128s-simple_clean/hash_sha2.c pqclean_sphincs-sha2-128s-simple_clean/merkle.c pqclean_sphincs-sha2-128s-simple_clean/sign.c pqclean_sphincs-sha2-128s-simple_clean/thash_sha2_simple.c pqclean_sphincs-sha2-128s-simple_clean/utils.c pqclean_sphincs-sha2-128s-simple_clean/utilsx1.c pqclean_sphincs-sha2-128s-simple_clean/wots.c pqclean_sphincs-sha2-128s-simple_clean/wotsx1.c)
    target_include_directories(sphincs_sha2_128s_simple_clean PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-128s-simple_clean)
    target_include_directories(sphincs_sha2_128s_simple_clean PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_128s_simple_clean>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_128s_simple_avx2)
    add_library(sphincs_sha2_128s_simple_avx2 OBJECT pqclean_sphincs-sha2-128s-simple_avx2/address.c pqclean_sphincs-sha2-128s-simple_avx2/context_sha2.c pqclean_sphincs-sha2-128s-simple_avx2/fors.c pqclean_sphincs-sha2-128s-simple_avx2/hash_sha2.c pqclean_sphincs-sha2-128s-simple_avx2/hash_sha2x8.c pqclean_sphincs-sha2-128s-simple_avx2/merkle.c pqclean_sphincs-sha2-128s-simple_avx2/sha256avx.c pqclean_sphincs-sha2-128s-simple_avx2/sha256x8.c pqclean_sphincs-sha2-128s-simple_avx2/sign.c pqclean_sphincs-sha2-128s-simple_avx2/thash_sha2_simple.c pqclean_sphincs-sha2-128s-simple_avx2/thash_sha2_simplex8.c pqclean_sphincs-sha2-128s-simple_avx2/utils.c pqclean_sphincs-sha2-128s-simple_avx2/utilsx8.c pqclean_sphincs-sha2-128s-simple_avx2/wots.c)
    target_include_directories(sphincs_sha2_128s_simple_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-128s-simple_avx2)
    target_include_directories(sphincs_sha2_128s_simple_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(sphincs_sha2_128s_simple_avx2 PRIVATE -mavx2)
    target_compile_options(sphincs_sha2_128s_simple_avx2 PUBLIC -fno-strict-aliasing)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_128s_simple_avx2>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_192f_simple)
    add_library(sphincs_sha2_192f_simple_clean OBJECT sig_sphincs_sha2_192f_simple.c pqclean_sphincs-sha2-192f-simple_clean/address.c pqclean_sphincs-sha2-192f-simple_clean/context_sha2.c pqclean_sphincs-sha2-192f-simple_clean/fors.c pqclean_sphincs-sha2-192f-simple_clean/hash_sha2.c pqclean_sphincs-sha2-192f-simple_clean/merkle.c pqclean_sphincs-sha2-192f-simple_clean/sign.c pqclean_sphincs-sha2-192f-simple_clean/thash_sha2_simple.c pqclean_sphincs-sha2-192f-simple_clean/utils.c pqclean_sphincs-sha2-192f-simple_clean/utilsx1.c pqclean_sphincs-sha2-192f-simple_clean/wots.c pqclean_sphincs-sha2-192f-simple_clean/wotsx1.c)
    target_include_directories(sphincs_sha2_192f_simple_clean PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-192f-simple_clean)
    target_include_directories(sphincs_sha2_192f_simple_clean PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_192f_simple_clean>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_192f_simple_avx2)
    add_library(sphincs_sha2_192f_simple_avx2 OBJECT pqclean_sphincs-sha2-192f-simple_avx2/address.c pqclean_sphincs-sha2-192f-simple_avx2/context_sha2.c pqclean_sphincs-sha2-192f-simple_avx2/fors.c pqclean_sphincs-sha2-192f-simple_avx2/hash_sha2.c pqclean_sphincs-sha2-192f-simple_avx2/hash_sha2x8.c pqclean_sphincs-sha2-192f-simple_avx2/merkle.c pqclean_sphincs-sha2-192f-simple_avx2/sha256avx.c pqclean_sphincs-sha2-192f-simple_avx2/sha256x8.c pqclean_sphincs-sha2-192f-simple_avx2/sha512x4.c pqclean_sphincs-sha2-192f-simple_avx2/sign.c pqclean_sphincs-sha2-192f-simple_avx2/thash_sha2_simple.c pqclean_sphincs-sha2-192f-simple_avx2/thash_sha2_simplex8.c pqclean_sphincs-sha2-192f-simple_avx2/utils.c pqclean_sphincs-sha2-192f-simple_avx2/utilsx8.c pqclean_sphincs-sha2-192f-simple_avx2/wots.c)
    target_include_directories(sphincs_sha2_192f_simple_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-192f-simple_avx2)
    target_include_directories(sphincs_sha2_192f_simple_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(sphincs_sha2_192f_simple_avx2 PRIVATE -mavx2)
    target_compile_options(sphincs_sha2_192f_simple_avx2 PUBLIC -fno-strict-aliasing)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_192f_simple_avx2>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_192s_simple)
    add_library(sphincs_sha2_192s_simple_clean OBJECT sig_sphincs_sha2_192s_simple.c pqclean_sphincs-sha2-192s-simple_clean/address.c pqclean_sphincs-sha2-192s-simple_clean/context_sha2.c pqclean_sphincs-sha2-192s-simple_clean/fors.c pqclean_sphincs-sha2-192s-simple_clean/hash_sha2.c pqclean_sphincs-sha2-192s-simple_clean/merkle.c pqclean_sphincs-sha2-192s-simple_clean/sign.c pqclean_sphincs-sha2-192s-simple_clean/thash_sha2_simple.c pqclean_sphincs-sha2-192s-simple_clean/utils.c pqclean_sphincs-sha2-192s-simple_clean/utilsx1.c pqclean_sphincs-sha2-192s-simple_clean/wots.c pqclean_sphincs-sha2-192s-simple_clean/wotsx1.c)
    target_include_directories(sphincs_sha2_192s_simple_clean PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-192s-simple_clean)
    target_include_directories(sphincs_sha2_192s_simple_clean PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_192s_simple_clean>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_192s_simple_avx2)
    add_library(sphincs_sha2_192s_simple_avx2 OBJECT pqclean_sphincs-sha2-192s-simple_avx2/address.c pqclean_sphincs-sha2-192s-simple_avx2/context_sha2.c pqclean_sphincs-sha2-192s-simple_avx2/fors.c pqclean_sphincs-sha2-192s-simple_avx2/hash_sha2.c pqclean_sphincs-sha2-192s-simple_avx2/hash_sha2x8.c pqclean_sphincs-sha2-192s-simple_avx2/merkle.c pqclean_sphincs-sha2-192s-simple_avx2/sha256avx.c pqclean_sphincs-sha2-192s-simple_avx2/sha256x8.c pqclean_sphincs-sha2-192s-simple_avx2/sha512x4.c pqclean_sphincs-sha2-192s-simple_avx2/sign.c pqclean_sphincs-sha2-192s-simple_avx2/thash_sha2_simple.c pqclean_sphincs-sha2-192s-simple_avx2/thash_sha2_simplex8.c pqclean_sphincs-sha2-192s-simple_avx2/utils.c pqclean_sphincs-sha2-192s-simple_avx2/utilsx8.c pqclean_sphincs-sha2-192s-simple_avx2/wots.c)
    target_include_directories(sphincs_sha2_192s_simple_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-192s-simple_avx2)
    target_include_directories(sphincs_sha2_192s_simple_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(sphincs_sha2_192s_simple_avx2 PRIVATE -mavx2)
    target_compile_options(sphincs_sha2_192s_simple_avx2 PUBLIC -fno-strict-aliasing)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_192s_simple_avx2>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_256f_simple)
    add_library(sphincs_sha2_256f_simple_clean OBJECT sig_sphincs_sha2_256f_simple.c pqclean_sphincs-sha2-256f-simple_clean/address.c pqclean_sphincs-sha2-256f-simple_clean/context_sha2.c pqclean_sphincs-sha2-256f-simple_clean/fors.c pqclean_sphincs-sha2-256f-simple_clean/hash_sha2.c pqclean_sphincs-sha2-256f-simple_clean/merkle.c pqclean_sphincs-sha2-256f-simple_clean/sign.c pqclean_sphincs-sha2-256f-simple_clean/thash_sha2_simple.c pqclean_sphincs-sha2-256f-simple_clean/utils.c pqclean_sphincs-sha2-256f-simple_clean/utilsx1.c pqclean_sphincs-sha2-256f-simple_clean/wots.c pqclean_sphincs-sha2-256f-simple_clean/wotsx1.c)
    target_include_directories(sphincs_sha2_256f_simple_clean PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-256f-simple_clean)
    target_include_directories(sphincs_sha2_256f_simple_clean PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_256f_simple_clean>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_256f_simple_avx2)
    add_library(sphincs_sha2_256f_simple_avx2 OBJECT pqclean_sphincs-sha2-256f-simple_avx2/address.c pqclean_sphincs-sha2-256f-simple_avx2/context_sha2.c pqclean_sphincs-sha2-256f-simple_avx2/fors.c pqclean_sphincs-sha2-256f-simple_avx2/hash_sha2.c pqclean_sphincs-sha2-256f-simple_avx2/hash_sha2x8.c pqclean_sphincs-sha2-256f-simple_avx2/merkle.c pqclean_sphincs-sha2-256f-simple_avx2/sha256avx.c pqclean_sphincs-sha2-256f-simple_avx2/sha256x8.c pqclean_sphincs-sha2-256f-simple_avx2/sha512x4.c pqclean_sphincs-sha2-256f-simple_avx2/sign.c pqclean_sphincs-sha2-256f-simple_avx2/thash_sha2_simple.c pqclean_sphincs-sha2-256f-simple_avx2/thash_sha2_simplex8.c pqclean_sphincs-sha2-256f-simple_avx2/utils.c pqclean_sphincs-sha2-256f-simple_avx2/utilsx8.c pqclean_sphincs-sha2-256f-simple_avx2/wots.c)
    target_include_directories(sphincs_sha2_256f_simple_avx2 PRIVATE ${CMAKE_CURRENT_LIST_DIR}/pqclean_sphincs-sha2-256f-simple_avx2)
    target_include_directories(sphincs_sha2_256f_simple_avx2 PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
    target_compile_options(sphincs_sha2_256f_simple_avx2 PRIVATE -mavx2)
    target_compile_options(sphincs_sha2_256f_simple_avx2 PUBLIC -fno-strict-aliasing)
    set(_SPHINCS_OBJS ${_SPHINCS_OBJS} $<TARGET_OBJECTS:sphincs_sha2_256f_simple_avx2>)
endif()

if(OQS_ENABLE_SIG_sphincs_sha2_256s_simple)

=== scripts/copy_from_upstream/src/kem/family/CMakeLists.txt ===
# SPDX-License-Identifier: MIT

# This file was generated by
# scripts/copy_from_upstream/copy_from_upstream.py

set(_{{ family|upper }}_OBJS "")

{%- if common_deps is defined %}
    {%- for common_dep in common_deps %}

if({% for used_by in common_deps_usedby[common_dep['name']] -%}OQS_ENABLE_KEM_{{ family }}_{{ used_by['scheme_c'] }}{%- if used_by['impl_name'] != default_implementation %}_{{ used_by['impl_name'] }}{% endif -%}{%- if not loop.last %} OR {% endif -%}{%- endfor -%})
    add_library({{ family }}_{{ common_dep['name'] }} OBJECT {% for source_file in common_dep['sources_addl']|sort -%}{{ upstream_location }}_{{ common_dep['name'] }}/{{ source_file }}{%- if not loop.last %} {% endif -%}{%- endfor -%})
    target_include_directories({{ family }}_{{ common_dep['name'] }} PRIVATE ${CMAKE_CURRENT_LIST_DIR}/{{ upstream_location }}_{{ common_dep['name'] }})
        {%- if common_dep['required_flags'] %}
    target_compile_options({{ family }}_{{ common_dep['name'] }} PRIVATE {%- for flag in common_dep['required_flags'] %}{%- if flag != 'arm_neon' %} -m{%- if flag == 'bmi1' -%} bmi {%- elif flag == 'sse4_1' -%} sse4.1 {%- elif flag == 'pclmulqdq' -%} pclmul {%- else -%}{{ flag }}{%- endif -%}{%- endif -%}{%- endfor -%})
        {%- endif %}
        {%- if common_dep['compile_opts'] %}
    target_compile_options({{ family }}_{{ common_dep['name'] }} PUBLIC {{ common_dep['compile_opts'] }})
        {%- endif %}
    set(_{{ family|upper }}_OBJS ${_{{ family|upper }}_OBJS} $<TARGET_OBJECTS:{{ family }}_{{ common_dep['name'] }}>)
endif()

    {%- endfor %}
{%- endif %}

{%- for scheme in schemes -%}
    {%- for impl in scheme['metadata']['implementations'] -%}
        {%- if impl['name'] == scheme['default_implementation'] %}

if(OQS_ENABLE_KEM_{{ family }}_{{ scheme['scheme_c'] }}{%- if 'alias_scheme' in scheme %} OR OQS_ENABLE_KEM_{{ family }}_{{ scheme['alias_scheme'] }}{%- endif %})
    add_library({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} OBJECT kem_{{ family }}_{{ scheme['scheme'] }}.c {% for source_file in impl['sources']|sort -%}{{ impl['upstream']['name'] }}_{{ scheme['pqclean_scheme'] }}_{{ impl['name'] }}/{{ source_file }}{%- if not loop.last %} {% endif -%}{%- endfor -%})
           {%- if impl['compile_opts'] %}
    target_compile_options({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PUBLIC {{ impl['compile_opts'] }})
           {%- endif -%}

        {%- elif impl['name'] == 'cuda' %}

if(OQS_ENABLE_KEM_{{ family }}_{{ scheme['scheme_c'] }}_{{ impl['name'] }}{%- if 'alias_scheme' in scheme %} OR OQS_ENABLE_KEM_{{ family }}_{{ scheme['alias_scheme'] }}_{{ impl['name'] }}{%- endif %})
    add_library({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} OBJECT {{ impl['upstream']['name'] }}_{{ scheme['pqclean_scheme'] }}_{{ impl['name'] }}/cupqc_ml-kem.cu)
    target_link_libraries({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} cupqc)
    set_property(TARGET {{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PROPERTY CUDA_ARCHITECTURES OFF)
    target_compile_options({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PRIVATE {{ impl['compile_opts'] }})

        {%- elif impl['name'] == 'icicle_cuda' %}

if(OQS_ENABLE_KEM_{{ family }}_{{ scheme['scheme_c'] }}_{{ impl['name'] }}{%- if 'alias_scheme' in scheme %} OR OQS_ENABLE_KEM_{{ family }}_{{ scheme['alias_scheme'] }}_{{ impl['name'] }}{%- endif %})
    add_library({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} OBJECT icicle_{{ scheme['pqclean_scheme'] }}_{{ impl['name'] }}/icicle_ml-kem.cpp)
    target_link_libraries({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PRIVATE icicle::icicle_pqc_package)
        {%- else %}

if(OQS_ENABLE_KEM_{{ family }}_{{ scheme['scheme_c'] }}_{{ impl['name'] }}{%- if 'alias_scheme' in scheme %} OR OQS_ENABLE_KEM_{{ family }}_{{ scheme['alias_scheme'] }}_{{ impl['name'] }}{%- endif %})
    add_library({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} OBJECT {% for source_file in impl['sources']|sort -%}{{ impl['upstream']['name'] }}_{{ scheme['pqclean_scheme'] }}_{{ impl['name'] }}/{{ source_file }}{%- if not loop.last %} {% endif -%}{%- endfor -%})
        {%- endif %}
        {%- if impl['name'] != 'cuda' and impl['name'] != 'icicle_cuda' %}
    target_include_directories({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PRIVATE ${CMAKE_CURRENT_LIST_DIR}/{{ impl['upstream']['name'] }}_{{ scheme['pqclean_scheme'] }}_{{ impl['name'] }})
    target_include_directories({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PRIVATE ${PROJECT_SOURCE_DIR}/src/common/pqclean_shims)
        {%- if impl['name'] != scheme['default_implementation'] and impl['required_flags'] -%}
           {%- set opts %}{% for flag in impl['required_flags'] %}{%- if flag != 'arm_neon' %} -m{%- if flag == 'bmi1' -%} bmi {% elif flag == 'sse4_1' -%} sse4.1 {% elif flag == 'pclmulqdq' -%} pclmul {% else -%}{{ flag }} {% endif %}{% endif -%}{% endfor %}{% endset %}
           {%- if opts|length > 0 %}
    target_compile_options({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PRIVATE {{ opts }})
           {%- endif -%}
        {%- endif %}
        {%- if impl['compile_opts'] %}
    target_compile_options({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PUBLIC {{ impl['compile_opts'] }})
        {%- endif %}
        {%- if family == 'classic_mceliece' and impl['name'] == 'avx2' %}
    target_compile_options({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PRIVATE -Wno-language-extension-token -O1)
        {%- endif %}
        {%- if family == 'hqc' and impl['name'] == 'clean' %}
    target_compile_options({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PRIVATE -O0)
        {%- endif %}
        {%- if impl['upstream']['name'].endswith('pqclean') %}
    if (CMAKE_SYSTEM_NAME STREQUAL "Darwin")
        target_compile_definitions({{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }} PRIVATE old_gas_syntax)
    endif()
    	{%- endif %}
        {%- endif %}{# cupqc #}
    set(_{{ family|upper }}_OBJS ${_{{ family|upper }}_OBJS} $<TARGET_OBJECTS:{{ family }}_{{ scheme['scheme'] }}_{{ impl['name'] }}>)
endif()
    {%- endfor -%}
{%- endfor %}

{% if libjade_implementation is defined -%}
##### OQS_COPY_FROM_LIBJADE_FRAGMENT_CMAKELISTS_START

##### OQS_COPY_FROM_LIBJADE_FRAGMENT_CMAKELISTS_END
{% endif -%}

set({{ family|upper }}_OBJS ${_{{ family|upper }}_OBJS} PARENT_SCOPE)

=== PKGBUILD ===
# Maintainer: d0p1 <contact@d0p1.eu>

_realname=liboqs
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=0.15.0
pkgrel=1
pkgdesc="C library for prototyping and experimenting with quantum-resistant cryptography (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://openquantumsafe.org/'
msys2_repository_url="https://github.com/open-quantum-safe/liboqs"
msys2_references=(
  'anitya: 364436'
  'aur: liboqs'
)
license=('spdx:MIT')
makedepends=(
  "${MINGW_PACKAGE_PREFIX}-cmake"
  "${MINGW_PACKAGE_PREFIX}-ninja"
  "${MINGW_PACKAGE_PREFIX}-cc"
)
checkdepends=(
  "${MINGW_PACKAGE_PREFIX}-python-pytest"
  "${MINGW_PACKAGE_PREFIX}-python-pytest-xdist"
  "${MINGW_PACKAGE_PREFIX}-python-yaml"
)
source=("https://github.com/open-quantum-safe/liboqs/archive/${pkgver}/${_realname}-${pkgver}.tar.gz"
        "001-aarch64-detection.patch")
sha256sums=('3983f7cd1247f37fb76a040e6fd684894d44a84cecdcfbdb90559b3216684b5c'
            '99a7133701b106e6e0d4d9dece250a2e63c1082c7c6835747ad69387bd29f958')

apply_patch_with_msg() {
  for _fname in "$@"
  do
    msg2 "Applying ${_fname}"
    patch -Nbp1 -i "${srcdir}"/${_fname}
  done
}

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}

  apply_patch_with_msg \
    001-aarch64-detection.patch
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${CC} == clang ]]; then
    export CFLAGS+=" -Wno-unknown-warning-option"
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      -DBUILD_SHARED_LIBS=ON \
      -DOQS_BUILD_ONLY_LIB=ON \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE.txt" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
